/**
 *
 * Author:            Philip
 * Company:         恒生电子股份有限公司
 * Created date:    2015/5/25
 *
 * function explain:
 *  微信分享
 */
define("weixinshare",['wx'], function(wx) {
    var action = {
        initWeixinShare : function (appId, timestamp, nonceStr, signature,
                         shareTitle, shareLink, shareOutPic, shareContent,originalLink) {

            shareTitle = decodeURIComponent(shareTitle);
            shareContent = decodeURIComponent(shareContent);

            wx.config({
                debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
                appId: appId, // 必填，公众号的唯一标识
                timestamp: timestamp, // 必填，生成签名的时间戳
                nonceStr: nonceStr, // 必填，生成签名的随机串
                signature: signature,// 必填，签名，见附录1
                jsApiList: ["onMenuShareTimeline", "onMenuShareAppMessage","onMenuShareQQ","onMenuShareQZone"] // 必填，需要使用的JS接口列表，所有JS接口列表见附录2
            });

            wx.ready(function () {
                //分享朋友圈
                wx.onMenuShareTimeline({
                    title: shareContent, // 分享标题,此处不使用标题，使用分享内容
                    link: shareLink, // 分享链接
                    imgUrl: shareOutPic, // 分享图标
                    success: function () {
                        console.log("success");
                    },
                    cancel: function () {
                        // 用户取消分享后执行的回调函数
                    }
                });
                //分享好友
                wx.onMenuShareAppMessage({
                    title: shareTitle, // 分享标题
                    desc: shareContent, // 分享描述
                    link: shareLink, // 分享链接
                    imgUrl: shareOutPic, // 分享图标
                    type: '', // 分享类型,music、video或link，不填默认为link
                    dataUrl: '', // 如果type是music或video，则要提供数据链接，默认为空
                    success: function () {
                        console.log("success");
                    },
                    cancel: function () {
                        // 用户取消分享后执行的回调函数
                    }
                });
                //分享到QQ
                wx.onMenuShareQQ({
                    title: shareTitle, // 分享标题
                    desc: shareContent, // 分享描述
                    link: originalLink, // 分享链接
                    imgUrl: shareOutPic, // 分享图标
                    success: function () {
                        // 用户确认分享后执行的回调函数
                    },
                    cancel: function () {
                        // 用户取消分享后执行的回调函数
                    }
                });
                //分享到QQ空间
                wx.onMenuShareQZone({
                    title: shareTitle, // 分享标题
                    desc: shareContent, // 分享描述
                    link: originalLink, // 分享链接
                    imgUrl: shareOutPic, // 分享图标
                    success: function () {
                        // 用户确认分享后执行的回调函数
                    },
                    cancel: function () {
                        // 用户取消分享后执行的回调函数
                    }
                });
            });
        }
    } ;
    return action;
});