// 中登改造插件
function zdlegalModule($) {
  var constants = {
    VDF: 'DF',
    V30: '3.0',
    V40: '4.0',
    V45: '4.5'
  }
  var action = {
    _private: {
      version: constants.V30,
      zdOptions: {},
      complianceTypes: {
        holdingname: "实际控制人",
        beneficiary: "实际受益人",
        agency: '代理人'
      },
      bsInfo: {
        agency: [],
        beneficiary: [],
        holdingname: []
      },
      bsRawList: [],
      // 关联人
      copyList: [],
      dictMap: {},
      dictNames: {
        bs_sex: "性别",
        bs_idtype: "证件类型",
        bs_workcode: "职业类型",
        liveCity: "居住城市",
        liveNation: "居住国家或地区",
        bs_livecity: '居住城市'
      },
      provinceDictData: [],
      dictValues: {}
    },
    // 修改资料
    // 初始化
    init: function (option) {
      var defaultOptions = {
        version: constants.V30,
        pickerUnSelectColor: 'm-color-6',
        allowUnder18: true // 是否有18岁以下存量用户
      }
      if ($.hsf.zdlegal) {
        var zdOptions = $.extend(defaultOptions, option)
        $(".zd-enable").removeClass('zd-enable');
        $(".zd-disable").hide().remove();
        if (zdOptions.version) {
          action._private.version = zdOptions.version;
        }
        if (zdOptions.version === constants.VDF) {
          action.queryDict('职业', 'workcodeDict', function (dictItems) {
            if (dictItems && dictItems.length > 0) {
              var options = dictItems.map(function (item) {
                return '<option value="' + item.key + '">' + item.value + '</option>'
              }).join('')
              $("#workcode").html(options)
            }
          })
        }
        action._private.zdOptions = zdOptions
      }
    },
    processUnderAge : function (accountInfo) {
      // 是否是未成年人
      var birthday, idAge;
      if (accountInfo.idtype == '0') {
        if (accountInfo.idAge) {
          idAge = accountInfo.idAge;
        } else {
          birthday = accountInfo.idno.substr(6, 8);
        }
      } else {
        birthday = accountInfo.birthday;
      }
      if (idAge || (birthday && birthday.replace(/-/g, "").length === 8)) {
        var isAdult = idAge >= 18 || $.hsf.hsTools.isAdult(birthday.replace(/-/g, ""))
        if (!isAdult) {
          $("#agency-change").show();
          $("#agency-change").on("tap", function () {
            $.UIPopup("未成年人必须添加代理人信息")
          })
        }
      }
      $("#birthday").UIDateField("change", function () {
        if ($("#agency-change").data("ready") !== '1') {
          return false;
        }
        if (accountInfo.idtype !== '0') {
          var birthD = $("#birthday").UIDateField("value");
          var isAdult = $.hsf.hsTools.isAdult(birthD.replace(/-/g, ""))
          if (!isAdult) {
            $("#agency-change").show();
            $(".compliance-agency").show();
            if ($(".compliance-agency").length == 0) {
              action.addBsItem('agency');
            }
            $("#agency-change").off("tap").on("tap", function () {
              $.UIPopup("未成年人必须添加代理人信息")
            })
          } else {
            $("#agency-change").hide();
            $(".compliance-agency").hide();
          }
        }
      })
    },
    // 填充用户信息
    packData: function (accountInfo, isOpenAcco, options) {
      var mobilekey, addresskey
      if (action._private.zdOptions.version === constants.V30 || action._private.zdOptions.version === constants.VDF) {
        accountInfo.provinceno = accountInfo.provincecode;
        mobilekey = 'handset';
        addresskey = 'communicationaddr';
      } else if (action._private.zdOptions.version === constants.V40){
        mobilekey = 'allmobile';
        addresskey = 'communicationaddr'
      } else if (action._private.zdOptions.version === constants.V45){
        accountInfo.provinceno = accountInfo.provincecode;
        accountInfo.countyno = accountInfo.opencountyno;
        accountInfo.cityno = accountInfo.opencityno;
        addresskey = 'address'
        mobilekey = 'dsmobile'
      }
      if ($.hsf.zdlegal) {
        this.events();
        if (options) {
          if (options.provinceDictData) {
            action._private.provinceDictData = options.provinceDictData;
          }
          // 非3.0字典赋值
          if (action._private.zdOptions.version !== constants.VDF) {
            action._private.provinceDictData = options.proviceAndCities;
            action._private.dictMap.nationDict = options.nationalityDict || options.nationality;
            action._private.dictMap.sexDict = options.genderDict;
            action._private.dictMap.workcodeDict = options.workcodeDict;
            action._private.dictMap.idtypeDict = options.idTypeDict;
          }
        }
        this.queryProvinceCities(function () {
          action.queryDict("国籍代码", "nationDict", function () {
            action.initDictValue('liveNation', 'nationDict', accountInfo.livenation)
            if (!isOpenAcco || accountInfo.provinceno) {
              action.transAddressToCode([accountInfo.provinceno, accountInfo.cityno, accountInfo.countyno], 'liveCity')
            } else {
              action.transAddressToCode(accountInfo.ocrAddress || '', 'liveCity')
            }
          })
        })
        if (!isOpenAcco) {
          var addressArr = (accountInfo[addresskey] || '').split("|");
          $("#liveAddress").UITextField("value", addressArr[addressArr.length - 1]);
        }
        if (isOpenAcco !== true) {
          // 处理未成年人，若没有未成年人可去掉该行
          if (action._private.zdOptions.allowUnder18) {
            this.processUnderAge(accountInfo);
          }
          this.queryBenifitAndShareholder(accountInfo);
          var mobileInfo = (accountInfo[mobilekey] || '').split('|')
          accountInfo[mobilekey] = mobileInfo[mobileInfo.length - 1];
          if (mobilekey == 'handset') {
            $("#handset").UITextField("value", accountInfo[mobilekey])
          } else {
            $("#mobile").UITextField("value", accountInfo[mobilekey])
          }
        }
        action._private.zdOptions.isOpenAcco = isOpenAcco
      } else {
        var mobileInfo = (accountInfo[mobilekey] || '').split('|')
        accountInfo[mobilekey] = mobileInfo[mobileInfo.length - 1];
        accountInfo[addresskey] = (accountInfo[addresskey] || '').replace(/\|/g, '')
      }
    },
    // 关联人初始化，在点击进入关联人修改页面时触发
    initCompliance: function () {
      var index = action.getParams('index'), type = action.getParams('type');
      var bsItems = action._private.bsInfo[type];
      var bsItem = bsItems[index] || {};
      function setValue (id, key) {
        $("#" + id).UITextField("value", bsItem[key] || '')
      }
      // 新电商版本右侧按钮被隐藏
      $("#compliance-info-change [m-role='UIButton']").css("visibility", "visible");
      setValue('bs_idno', 'bs_id_no')
      setValue('bs_name', 'bs_name')
      setValue('bs_email', 'stakeholders_email')
      setValue('bs_zipcode', 'stakeholders_zipcode')
      this.initDict();
      this.initDictValue('bs_nation', 'nationDict', bsItem.bs_nation || "156")
      this.initDictValue('bs_idtype', 'idtypeDict', bsItem.bs_id_kind_gb || '0')
      this.initDictValue('bs_sex', 'sexDict', bsItem.stakeholders_sex || '')
      this.initDictValue('bs_workcode', 'workcodeDict', bsItem.stakeholders_work || '')
      if (bsItem.bs_id_enddate == '99991231') {
        $("#endDateSwitch").UISwitch('state', 'on')
        $("#bs_enddate").UIDateField('value', '')
      } else {
        $("#endDateSwitch").UISwitch('state', 'off')
        if (bsItem.bs_id_enddate) {
          $("#bs_enddate").UIDateField('value', $.hsf.hsTools.yyyy_mm_dd(bsItem.bs_id_enddate))
        } else {
          $("#bs_enddate").UIDateField('value', '')
        }
      }
      if (bsItem.stakeholders_birthday) {
        $("#bs_birthday").UIDateField('value', $.hsf.hsTools.yyyy_mm_dd(bsItem.stakeholders_birthday))
      } else {
        $("#bs_birthday").UIDateField('value', '')
      }
      if (bsItem.benifit_address) {
        var namesArr = bsItem.benifit_address.split('|');
        var liveAddress = namesArr[namesArr.length - 1]; // 最后一个
        $("#bs_liveaddress").UITextField("value", liveAddress)
        action.transAddressToCode(namesArr.slice(0, namesArr.length - 1), 'bs_livecity')
      } else {
        this.initDictValue('bs_livecity', 'liveCityDict', '')
        $("#bs_liveaddress").UITextField("value", "")
      }
      var mobileInfo = (bsItem.stakeholders_phone || '').split('|')
      var mobileNo;
      if (mobileInfo.length === 3 && mobileInfo[1]) {
        mobileNo = mobileInfo.slice(1).join('-')
      } else {
        mobileNo = mobileInfo[mobileInfo.length - 1];
      }
      // 区号 - 电话
      $("#bs_mobile").UITextField("value", mobileNo)
      // birthday设置最大、最小值
      var $birthday = $("#bs_birthday").clone()
        .attr('m-min', $.hsf.hsTools.yyyy_mm_dd($.hsf.hsTools.addNYearsLater(-100)))
        .attr('m-max', $.hsf.hsTools.yyyy_mm_dd($.hsf.hsTools.addNYearsLater(0)))
        .removeData("UIDateField").empty().UIDateField()
      $("#bs_birthday").parent().empty().append($birthday)
      // 证件有效期重新初始化
      var $enddate = $("#bs_enddate").clone()
        .attr('m-min', $.hsf.hsTools.yyyy_mm_dd($.hsf.hsTools.addNYearsLater(0)))
        .attr('m-max', $.hsf.hsTools.yyyy_mm_dd($.hsf.hsTools.addNYearsLater(20)))
        .removeData("UIDateField").empty().UIDateField()
      $("#bs_enddate").parent().empty().append($enddate)
    },
    // events
    events: function () {
      // 选择
      $(".picker").on("tap", function () {
        // 使input失焦
        $("input").blur();
        var $this = $(this);
        var id = $this.attr("id");
        var private = action._private;
        var dictValues = action._private.dictValues;
        var title;
        var cities = action._private.provinceDictData;
        var outsides = [{
          proviceno: '99',
          provicename: '境外'
        }]
        var data;
        // 港澳台特殊处理 台 158  港344  澳446
        var specialProvinceMap = {
          "158": "71",
          "344": "81",
          "446": "82"
        }
        if (id == 'liveCity') {
          // 判断是否已已选择居住国家
          if (!dictValues.liveNation && !dictValues.liveCity) {
            $.UIPopup("请先选择现居国家或地区")
            return false;
          }
          var liveNation = dictValues.liveNation.value[0];
          if (specialProvinceMap[liveNation]) {
            data = cities.filter(function (item) {
              return item.proviceno == specialProvinceMap[liveNation]
            })
          } else if (liveNation !== '156') {
            data = outsides
          } else {
            // 修改资料选择中国去除境外
            data = cities.filter(function (item) {
              return item.proviceno != '99'
            })
          }
          title = "居住城市"
          action.normalizeDict("city", data)
        } else if (id==='bs_livecity') {
          data = cities;
          title = "居住城市"
          action.normalizeDict("city", data)
        } else if (id === 'liveNation' || id === 'bs_nation') {
          data = private.dictMap['nationDict'];
          action.normalizeDict("nation", data)
          title = "居住国家或地区"
          if (id == 'bs_nation') {
            title = "国家或地区"
          }
          if (!dictValues[id]) {
            $.each(data, function (index, item) {
              if (item.key === '156') {
                dictValues[id] = {
                  index: [index],
                  value: [item.key],
                  caption: [item.value]
                }
                return false;
              }
              return true;
            })
          }
        } else {
          var dictname = id;
          if (id.indexOf("bs_") == 0) {
            dictname = id.substr(3)
          }
          data = private.dictMap[dictname + 'Dict'];
          title = private.dictNames[id]
          action.normalizeDict(id, data)
        }
        var index = dictValues[id] ? dictValues[id].index : [0]
        var qSelect = new QSelect({
          title: "请选择" + title,
          // index:  index,
          data: data,
          disableDefaultCancel: true,
          cancel: function () {
            qSelect.close()
            setTimeout(function () {
              qSelect.destroy();
            }, 200)
          },
          confirm: function (values, keys, data) {
            // 点击确定
            var result = values.join("");
            if (values[0] === values[1] && !values[2]) {
              result = values[1];
            }
            $this.find(".picker-value").text(result).removeClass(action._private.zdOptions.pickerUnSelectColor)
            var lastDictValues = dictValues[id];
            dictValues[id] = {
              value: keys,
              caption: values,
              index: qSelect.getIndex()
            }
            if (id === 'bs_idtype') {
              $("#bs_idno").UITextField("idtype", keys[0]);
            } else if (id === 'liveNation' && keys[0] !== '156' && specialProvinceMap[keys[0]]) {
              // 港澳台
              dictValues.liveCity = null;
              $("#liveCity").find(".picker-value").text("请选择居住城市").addClass(action._private.zdOptions.pickerUnSelectColor)
            } else if (id === 'liveNation' && keys[0] !== '156') {
              // 非中国，城市置为境外
              dictValues.liveCity = {
                value: [outsides[0].proviceno],
                caption: [outsides[0].provicename],
                index: [0]
              }
              $("#liveCity").find(".picker-value").text("境外").removeClass(action._private.zdOptions.pickerUnSelectColor)
            } else if (id === 'liveNation' && keys[0] === '156' && ((dictValues.liveCity && dictValues.liveCity.value[0] == '99') || specialProvinceMap[lastDictValues ? lastDictValues.value[0] : ' '])) {
              dictValues.liveCity = null;
              $("#liveCity").find(".picker-value").text("请选择居住城市").addClass(action._private.zdOptions.pickerUnSelectColor)
            }
            setTimeout(function () {
              $(".q-select-header-cancel").trigger("click")
            }, 200)
          }
        });
        $(".q-select-bk").on("tap", function () {
          $(".q-select-header-cancel").trigger("click")
          return false;
        })
        qSelect.show();
        qSelect.setIndex(index)
        return false;
      });
      // 关联人信息
      $("#complianceTabView").on("tap", "dd", function (index) {
        var $this = $(this);
        var type = $this.data('type');
        var typeStr = action._private.complianceTypes[type];
        var bsItems = action._private.bsInfo[type];
        if ($this.hasClass('compliance-add')) {
          if (bsItems.length > 0 && !bsItems[bsItems.length - 1].valid) {
            // 添加先判断最后一个是否已完善
            $.UIPopup("请先完善上一条" + typeStr + "信息")
          } else {
            action.showCopyDialog(type)
          }
        } else if ($this.hasClass('compliance-dd')) {
          // 调整页面
          var index = $this.data('index');
          lastPosition['#investment-suitability-a'] = $("html").scrollTop();
          window.location.hash = 'compliance-info-change?index=' + index + '&type=' + type;
          $("#compliance-info-change div[m-role='title']").text((action._private.complianceTypes[type]) + (index + 1));
        }
        return false;
      })
      // 关联人复制弹框遮罩
      $('.compliance-mask').on("tap", function () {
        $('.compliance-mask').hide();
        $(".change-compliance").removeClass("active")
        return false;
      })
      // 关联人复制弹框
      $(".change-compliance").on("tap", ".btn-copy", function () {
        // 复制
        var type = $(".change-compliance").data("type");
        var copyIndex = $(this).data('index')
        var copyList = action._private.copyList;
        action.addBsItem(type, copyList[copyIndex], true)
        $('.compliance-mask').trigger('tap');
        return false;
      }).on("tap", ".btn-add-others", function () {
        // 添加其他
        var type = $(".change-compliance").data("type");
        action.addBsItem(type)
        $('.compliance-mask').trigger('tap');
        return false;
      }).on("tap", "#closeCompliance", function () {
        $('.compliance-mask').trigger('tap')
        return false;
      })
      var lastPosition = {};
      // if (window.location.hash !== '' && window.location.hash != '#investment-suitability-a') {
      //   window.history.back();
      // }
      // hash监听
      window.addEventListener("hashchange", function (e) {
        var hash = window.location.hash.split("?")[0];
        if (hash === "") {
          hash = "#investment-suitability-a"
        }
        // var lastHash = '#' + (e.oldURL.split("#")[1] || 'investment-suitability-a');
        // lastPosition[lastHash] = $("html").scrollTop();
        if ($(hash).children("[m-role='UINavigationBar']").length != 0) {
          $(hash).parent().children("[m-role='UINavigationBar']").hide();
        } else {
          $(hash).parent().children("[m-role='UINavigationBar']").show();
        }
        $(hash).addClass("view-active").siblings(".view").removeClass("view-active")
        // 恢复上次位置
        if (hash === '#investment-suitability-a') {
          $("#btnDelete").hide();
          $("html").scrollTop(lastPosition[hash] || 0)
        } else {
          if (hash === '#compliance-info-change') {
            // if (window.location.href.indexOf("account-openAcco") >= 0) {
              $("#btnDelete").show();
            // }
            action.initCompliance();
          }
          $("html").scrollTop(0)
        }
      })
      // 关联人返回按钮
      $("#complianceBackBtn").on("tap", function () {
        window.history.back();
        return false;
      })
      // 关联人-证件有效期
      $("#endDateSwitch").UISwitch("change",function(v) {
        var $this = $("#endDateSwitch")
				if(v == 1){
          $this.parents("dd").next().hide()
          $this.prev().text("长期")
        } else {
          $this.parents("dd").next().show()
          $this.prev().text("短期")
        }
      });
      // 关联人确定按钮
      $("#complianceBtn").on("tap", function () {
        function getDictValue (key, dft) {
          return action._private.dictValues[key] ? action._private.dictValues[key].value[0] : (dft || "")
        }
        var bsIdno = $("#bs_idno").UITextField("value")
        var bsName = $("#bs_name").UITextField("value")
        var bsIdtype = getDictValue("bs_idtype")
        var bsEnddate = $("#endDateSwitch").attr("m-value") == '1' ? '99991231' : $("#bs_enddate").UIDateField('value')
        var bsSex = getDictValue("bs_sex");
        var bsBirthday = $("#bs_birthday").UIDateField('value')
        var bsNation = getDictValue("bs_nation")
        var bsWorkcode = getDictValue("bs_workcode")
        var bsMobile = $("#bs_mobile").UITextField("value")
        var bsLivecity = action._private.dictValues["bs_livecity"] ? action._private.dictValues["bs_livecity"].caption.join("|") : ''
        var bsLiveaddress = $("#bs_liveaddress").UITextField("value")
        var bsEmail = $("#bs_email").UITextField("value")
        var bsZipcode = $("#bs_zipcode").UITextField("value")
        var validForm = $.validForm();
        validForm.hope("notEmpty", bsName, "请输入姓名")
          .hope("commonName", bsName, "请正确输入姓名")
          .hope("notEmpty", bsIdtype, "请选择证件类型")
          .hope("notEmpty", bsIdno, "请输入证件号码");
        if (action._private.zdOptions.version === constants.VDF) {
          bsIdtype === '0' && validForm.hope("cerfiticate", bsIdno, "身份证格式不正确")
        } else {
          bsIdtype === '0' && validForm.hope("certificate", bsIdno, "身份证格式不正确")
        }
        validForm.hope("notEmpty", bsEnddate, "请选择证件有效期")
          .hope("notEmpty", bsSex, "请选择性别")
          .hope("notEmpty", bsBirthday, "请选择出生日期")
          .hope("notEmpty", bsWorkcode, "请选择职业");

        validForm.hope("notEmpty", bsMobile, "请输入联系方式").hope(function () {
          return validForm.test('mobile', bsMobile) || validForm.test('telphone', bsMobile)
        }, bsMobile, "联系方式格式不正确")
          .hope("notEmpty", bsLivecity, "请选择居住城市")
            .hope("notEmpty", bsLiveaddress, "请输入居住详细地址").hope(function () {
          return validForm.test('shortAddress', bsLiveaddress)
        }, bsLiveaddress, "请完善居住地址")
            .hope("notEmpty", bsEmail, "请输入电子邮箱").hope("email", bsEmail, "请输入电子邮箱", "电子邮箱格式不正确")
          .hope("notEmpty", bsZipcode, "请输入邮政编码").hope("zip", bsZipcode, "邮政编码格式不正确")
        if (validForm.valid()) {
          $("input").blur();
          var mobileArr = bsMobile.split(/[-]/);
          if (mobileArr.length === 1) {
            mobileArr.unshift('');
          }
          // 确保格式为：省|市|区|详细地址 没值的留空
          var provinceCityNames = action._private.dictValues["bs_livecity"].caption;
          if (action._private.dictValues["bs_livecity"].value[0] == '99') {
            provinceCityNames[1] = ""; // 处理掉多余的境外
            provinceCityNames[2] = "";
          }
          // 确保最终长度为3
          for(var i = 0;i < 3; i++) {
            if (!provinceCityNames[i]) {
              provinceCityNames[i] = "";
            }
          }
          var benifit_address = provinceCityNames.concat(bsLiveaddress).join('|')
          var bsItem = {
            valid: true,
            bs_name: bsName,
            bs_id_no: bsIdno,
            bs_id_kind_gb: bsIdtype,
            bs_id_enddate: bsEnddate.replace(/-/g, ""),
            stakeholders_sex: bsSex,
            stakeholders_birthday: bsBirthday.replace(/-/g, ""),
            bs_nation: bsNation,
            stakeholders_work: bsWorkcode,
            stakeholders_phone: ["86"].concat(mobileArr).join('|'),
            benifit_address: benifit_address,
            stakeholders_email: bsEmail,
            stakeholders_zipcode: bsZipcode
          }
          var index = action.getParams('index'), type = action.getParams('type');
          var bsItems = action._private.bsInfo[type];
          // 1-新增，2-修改
          bsItem.jsonopttype = bsItems[index] && bsItems[index].bs_mark_id ? "2" : "1"
          if (type === 'beneficiary') {
            bsItem.stakeholders_type = "2"
          } else if (type === 'holdingname') {
            bsItem.stakeholders_type = "1"
          } else {
            bsItem.stakeholders_type = "0"
          }
          bsItems[index] = bsItem
          // 修改显示名称
          $(".compliance-"+type).eq(index).find(".compliance-value").text(bsItem.bs_name).removeClass(action._private.zdOptions.pickerUnSelectColor)
          window.history.back();
          return false;
        }
      })
      $("#btnDelete").on("tap", function () {
        var title = $("#compliance-info-change div[m-role='title']").text();
        $.UIConfirm("确定删除" + title + '?', function (isOk) {
          if (isOk === 'yes') {
            var index = action.getParams('index'), type = action.getParams('type');
            var bsItems = action._private.bsInfo[type];
            bsItems.splice(index, 1);
            if (bsItems.length == 0) {
              // 全部删除，改为本人
              if (type === 'agency') {
                // 未成年人必须填写代理人
                $(".compliance-dd.compliance-"+type).remove()
                bsItems.splice(0)
                // action.addBsItem('agency');
              } else {
                $("." + type + '-period-change').text('本人')
                bsItems.splice(0)
                $(".compliance-"+type).remove()
              }
            } else {
              $(".compliance-"+type).eq(index).remove();
              for(i in bsItems){
                var $complianceDD = $($(".compliance-dd.compliance-"+type)[i]);
                $complianceDD.attr("data-index",i);
                $complianceDD.find(".compliance-key").html(title.substring(0,title.length-1)+(parseInt(i)+1)+'<span class="font-color-red">*</span>');
              }
            }
            setTimeout(function () {
              window.history.back();
            }, 100)
          }
        })
      })
      $("#bs_mobile_tips").on("tap", function () {
        $.UIAlert("联系方式请填写手机号码或者固定电话，固定电话格式为区号-电话号码，例：021-8888");
        return false;
      })
    },
    // 添加关联人
    addBsItem: function (type, targetItem, isCopy) {
      var typeStr = action._private.complianceTypes[type];
      var bsItems = action._private.bsInfo[type];
      var stakeholders_type;
      if (type === 'beneficiary') {
        stakeholders_type = "2"
      } else if (type === 'holdingname') {
        stakeholders_type = "1"
      } else {
        stakeholders_type = "0"
      }
      var item = $.extend({}, targetItem, {
        valid: targetItem && (targetItem.valid || targetItem.bs_mark_id) ? true : false,
        stakeholders_type: stakeholders_type
      })
      if (isCopy) {
        item.jsonopttype = "1"; // 新增
        item.bs_mark_id = null;
      }
      bsItems.push(item)
      var htmlTemp = doT.template($("#compliance-temp").text(), undefined).call(this, {
        valid: item.valid,
        type: type,
        typestr: typeStr,
        index: bsItems.length - 1,
        bs_name: item.bs_name || ''
      })
      // 有没有添加按钮
      var $addBtn = $("#"+type+"-change").parent("dl").find(".compliance-add.compliance-" + type);
      if ($addBtn.length == 0) {
        var htmlAdd = doT.template($("#compliance-addbtn-temp").text(), undefined).call(this, {
          type: type,
          typestr: typeStr
        })
        $("#"+type+"-change").after(htmlAdd).after(htmlTemp);
      } else {
        $addBtn.before(htmlTemp)
      }
      $("." + type + '-period-change').text(type === 'agency' ? '有' : '他人')
    },
    // 显示复制的弹框
    showCopyDialog: function (type) {
      var typeStr = action._private.complianceTypes[type];
      var otherKey = type === 'beneficiary' ? 'holdingname' : 'beneficiary';
      var otherItems = action._private.bsInfo[otherKey];
      if (type !== 'agency' && otherItems.length > 0 && otherItems[0].valid) {
        // 去重
        var bsItems = action._private.bsInfo[type];
        var curMap = bsItems.reduce(function (all, cur) {
          var key =  [cur.bs_name, cur.bs_id_kind_gb, cur.bs_id_no].join("-")
          all[key] = true
          return all
        }, {})
        var tempMap = {}
        var copyList = otherItems.filter(function (item) {
          var key = [item.bs_name, item.bs_id_kind_gb, item.bs_id_no].join("-")
          if (tempMap[key]) return false;
          tempMap[key] = true
          return item.valid && !curMap[key]
        })
        if (copyList.length > 0) {
          var copyListHtml = doT.template($("#compCopyTemp").text(), undefined).call(this, {
            title: '添加' + typeStr,
            items: copyList
          })
          action._private.copyList = copyList;
          $('.compliance-mask').show();
          $(".change-compliance").data("type", type).find(".compliance-content").empty().prepend(copyListHtml).end().addClass("active")
        } else {
          action.addBsItem(type)
        }
      } else {
        action.addBsItem(type)
      }
    },
    // methods public
    // 关联人切换
    onChoose: function (type, isOthers) {
      var typeStr = action._private.complianceTypes[type];
      var bsItems = action._private.bsInfo[type];
      // 由本人切换为他人
      if (isOthers) {
        // 确认另一个类型是否已添加
        action.showCopyDialog(type)
      } else { // 由他人切换为本人
        // 是否有已完善的信息
        if (bsItems[0] && bsItems[0].valid) {
          // 提示
          $.UIConfirm("选择"+typeStr+"为本人将删除已添加的"+typeStr+"信息，是否确定？", function (isOk) {
            if (isOk === 'yes') {
              bsItems.splice(0)
              $(".compliance-"+type).remove()
              $("." + type + '-period-change').text('本人')
            }
          })
        } else {
          $("." + type + '-period-change').text('本人')
          bsItems.splice(0)
          $(".compliance-"+type).remove()
        }
      }
    },
    // 表单校验
    // 通过type来分开校验
    validateForm: function (type) {
      if ($.hsf.zdlegal) {
        if (!type || type === 'liveaddr') {
          var dictValues = action._private.dictValues;
          if (!dictValues.liveNation) {
            action.scrollIntoView('liveNation');
            return "请选择居住国家或地区";
          }
          if (!dictValues.liveCity) {
            action.scrollIntoView('liveCity');
            return "请选择居住城市";
          }
          var liveAddress = $("#liveAddress").UITextField("value");
          if (!liveAddress) {
            action.scrollIntoView('liveNation', 'liveAddress');
            return "请输入详细地址"
          }
          var validResult = $.validForm().test('shortAddress', liveAddress)
          if (validResult !== true) {
            action.scrollIntoView('liveNation', 'liveAddress');
            return validResult;
          }
        }
        if (!type || type === 'compliance') {
          var bsInfo = action._private.bsInfo;
          var needModify = function (key) {
            return $("." + key + "-period-change").text() !== '本人' &&
              (bsInfo[key].length == 0 || !(bsInfo[key][bsInfo[key].length - 1].valid))
          }
          // 未成年人
          if ($("#agency-change").is(":visible")) {
            var needAgent = bsInfo['agency'].length == 0
            if (needAgent) {
              action.scrollIntoView('agency-change')
              return "未成年人必须添加代理人信息";
            }
            // 关联人信息选择了却没完善信息
            if (needModify('agency')) {
              action.scrollIntoView('agency-change')
              return "存在未完善的代理人信息";
            }
          }
          if (needModify('holdingname')) {
            action.scrollIntoView('holdingname-change')
            return "存在未完善的实际控制人信息";
          }
          if (needModify('beneficiary')) {
            action.scrollIntoView('beneficiary-change');
            return "存在未完善的实际受益人信息";
          }
        }
      }
      return true;
    },
    // 获取要提交接口的数据
    getFormData: function (autoGenerate, isOpenAcco) {
      var private = action._private;
      var dictValues = private.dictValues;
      var livenation = dictValues.liveNation.value[0];
      var liveAddress = $("#liveAddress").UITextField("value");
      var queryBenifitAndShareholders = [];
      var bsInfoMap = {}
      if (!$("#agency-change").is(":visible")) {
        private.bsInfo['agency'].splice(0)
      }
      $.each(private.bsInfo, function (key, items) {
        $.each(items, function (index, item) {
          if (item.bs_mark_id) {
            bsInfoMap[item.bs_mark_id] = true
          }
          // 没有修改则不提交
          if (!item.bs_mark_id || (!!item.jsonopttype && "1,2,3".indexOf(item.jsonopttype) != -1)) {
            item.jsonopttype = item.bs_mark_id ? "2" : "1"
            if (item.benifit_address) {
              item.benifit_address = item.benifit_address.replace(/&/g, "|")
            }
            if (item.stakeholders_phone) {
              item.stakeholders_phone = item.stakeholders_phone.replace(/&/g, "|")
            }
            queryBenifitAndShareholders.push(item)
          }
        })
      })
      if (private.bsRawList && private.bsRawList.length > 0) {
        $.each(private.bsRawList, function (index, item) {
          if (!bsInfoMap[item.bs_mark_id]) { // 找不到则删除
            queryBenifitAndShareholders.push({
              jsonopttype: "3",
              bs_mark_id: item.bs_mark_id
            })
          }
        })
      }

      var liveCity = dictValues.liveCity;
      var provincecode = liveCity.value[0] || '';
      var liveCityNames = liveCity.caption;
      // 确保长度为3
      for (var i = 0; i < 3; i++) {
        if (!liveCityNames[i]) {
          liveCityNames[i] = "";
        }
      }
      var data = {
        livenation: livenation,
        communicationaddr: encodeURIComponent(liveCityNames.concat(liveAddress).join('|')),
        myselfisbfcy: $(".beneficiary-period-change").text() === '本人' ? '1' : '0',
        myselfiscontorler: $(".holdingname-period-change").text() === '本人' ? '1' : '0',
        // cityno: (provincecode == "99" ? "" : (liveCity.value[1] || "")),
        // countyno: liveCity.value[2] || ''
      }
      if(isOpenAcco) {
        data.custprovincecode = provincecode;
        data.custcityno = (provincecode == "99" ? "" : (liveCity.value[1] || ""))
        data.custcountyno = liveCity.value[2] || ''
      } else {
        data.provincecode = provincecode
        data.cityno = (provincecode == "99" ? "" : (liveCity.value[1] || ""))
        data.countyno = liveCity.value[2] || ''
      }
      if (action._private.zdOptions.version == constants.V30 || action._private.zdOptions.version === constants.VDF) {
        // var handset = $("#handset").UITextField("value")
        // data.provincecode = provincecode
        // data.handset = encodeURIComponent(['86', handset].join('|'))
      } else  if (action._private.zdOptions.version == constants.V40) {
        var mobile = $("#mobile").UITextField("value")
        data.provinceno = provincecode
        data.mobile = encodeURIComponent(['86', mobile].join('|'))
      } else if (action._private.zdOptions.version === constants.V45) {
        data.address = data.communicationaddr;
        delete data.communicationaddr;
        data.provincecode = provincecode;
        data.opencityno = data.cityno;
        delete data.cityno;
        data.opencountyno = data.countyno;
        delete data.countyno;
        var mobile = $("#mobile").UITextField("value")
        if (action._private.zdOptions.isOpenAcco) {
          data.mobiletel = ['86', mobile].join('|')
        } else {
          data.newmobile = ['86', mobile].join('|')
          data.modifymobilerange = '0'
        }
      }
      if (queryBenifitAndShareholders.length > 0) {
        data.jsoncontent = encodeURIComponent(JSON.stringify({ benifitList: queryBenifitAndShareholders }))
      }
      if (autoGenerate !== false) {
        var dataArr = [];
        $.each(data, function (key, value) {
          dataArr.push(key + "=" + value);
        })
        return dataArr.join('&');
      }
      return data;
    },
    // methods private
    // 滚动到可见区域
    scrollIntoView: function (id, id2) {
      var $view = $("#" + id);
      var $view2 = $("#" + id2);
      setTimeout(function () {
        if ($view && $view[0]) {
          $view[0].scrollIntoView()
          if ($view2 && $view2.attr("m-role") == 'UITextField') {
            $view2.find("input").focus();
          }
        }
      }, 200)
    },
    // 省市区字典处理
    normalizeDict: function (type, data) {
      if (type == 'city') {
        $.each(data, function (index, v) {
          v.value = v.provicename || v.cityname || v.countryname || v.countyname;
          v.key = v.proviceno || v.cityno || v.countryno || v.countyno;
          var children = null
          if (v.cities) {
            children = v.cities.list ? v.cities.list : v.cities;
          } else if (v.contries) {
            children = (v.contries.list ? v.contries.list : v.contries);
          } else if (v.counties) {
            children = v.counties;
          }
          if (children) {
            action.normalizeDict(type, children);
            v.children = children
          }
        });
      } else {
        $.each(data, function (index, v) {
          if (v.keyvalue) {
            v.value = v.caption;
            v.key = v.keyvalue;
          }
        });
      }
    },
    // 初始化字典
    initDict: function (callback) {
      this.queryDict("性别", "sexDict", "#sex select")
      this.queryDict("职业", "workcodeDict", "#workcode")
      this.queryDict("证件", "idtypeDict", "#idTypeSel select")
      this.queryDict("国籍代码", "nationDict", callback)
      this.queryProvinceCities();
    },
    // 赋初始值
    initDictValue: function (id, key, dfKey) {
      var dictValues = action._private.dictValues;
      if (dfKey) {
        $.each(action._private.dictMap[key], function (index, item) {
          var itemkey = (item.keyvalue || item.key);
          var itemcaption = (item.caption || item.value);
          if (itemkey === dfKey) {
            dictValues[id] = {
              index: [index],
              value: [itemkey],
              caption: [itemcaption]
            }
            $('#' + id).find(".picker-value").text(itemcaption).removeClass(action._private.zdOptions.pickerUnSelectColor)
            return false;
          }
          return true;
        })
      } else {
        dictValues[id] = null
        $('#' + id).find(".picker-value").text("请选择" + action._private.dictNames[id]).addClass(action._private.zdOptions.pickerUnSelectColor)
      }
    },
    queryDict: function (dictname, dictKey, selector, callback) {
      var dictMap = action._private.dictMap;
      if (typeof selector == 'function') {
        callback = selector;
        selector = ''
      }
      if (!dictMap[dictKey]) {
        if (selector) {
          dictMap[dictKey] = action.getDictFromSelect(selector)
          callback && callback(dictMap[dictKey])
        } else {
          var url;
          if(action._private.version === constants.VDF) {
            url = 'system/dictionary'
          } else if (action._private.version === constants.V30) {
            url = 'atomicquery/account/dict'
          }
          if (!url) {
            callback && callback([])
            return;
          }
          $.hsf.ajax.app(url, "dictname="+dictname, "dictQueryCallback", function (jsonResult) {
            if (jsonResult.successful === true || jsonResult.successful === 'true') {
              var dictItems;
              try {
                dictItems = jsonResult.dictResult.items;
              } catch(e) {
                dictItems = [];
              }
              dictMap[dictKey] = dictItems;
              callback && callback(dictItems)
            } else {
              $.hsf.callFailProcess(jsonResult);
            }
          })
        }
      } else {
        callback && callback(dictMap[dictKey])
      }
    },
    queryProvinceCities: function (callback) {
      if (!(action._private.provinceDictData && action._private.provinceDictData.length > 0)) {
        $.hsf.ajax.app("account/crs/querycrsinfodict", "", "proviceandcitiesCallback", function (jsonResult) {
          if (jsonResult.successful === true || jsonResult.successful === 'true') {
            var dictItems =  jsonResult.proviceAndCities;
            action._private.provinceDictData = dictItems;
            callback && callback()
          } else {
            $.hsf.callFailProcess(jsonResult);
          }
        })
      } else {
        callback && callback();
      }
    },
    queryBenifitAndShareholder: function (accountInfo) {
      var url
      if(action._private.version === constants.VDF) {
        url = 'account/querybenifitandshareholder'
      } else if (action._private.version === constants.V30) {
        url = 'atomicquery/account/querybenifitandshareholder'
      } else {
        url = 'account/compliance/querybenifitandshareholder'
      }
      return $.hsf.ajax.app(url, "", "querybsCallback", function (jsonResult) {
        if (jsonResult.code=="ETS-5BP0000" || jsonResult.successful === true || jsonResult.successful === 'true' || jsonResult.code === 'ETS-5BPC0851') {

          var benifitAndShareholders = [];
          try {
            if (action._private.version == constants.VDF) {
              benifitAndShareholders = jsonResult.results.returnList.list;
            } else if (action._private.version == constants.V30) {
              benifitAndShareholders = jsonResult.returnList;
            } else {
              benifitAndShareholders = jsonResult.queryBenifitAndShareholders
            }
          } catch(e) {}
          action._private.bsRawList = benifitAndShareholders;
          var bsInfo = action._private.bsInfo;
          bsInfo.beneficiary = []
          bsInfo.holdingname = []
          var hasAgency = $("#agency-change").is(":visible");
          $(".compliance-dd").remove();
          $(".compliance-add").remove();
          if (benifitAndShareholders && benifitAndShareholders.length > 0) {
            benifitAndShareholders.sort(function (a, b) { return a.bs_mark_id - b.bs_mark_id})
            .reduce(function (bsInfo, cur, index) {
              if (action._private.zdOptions.version !== constants.VDF) {
                cur.bs_id_no = cur.bs_id_no;
              }
              if (cur.stakeholders_type === '2') { // 0-代理人,1-实控人，2-受益人
                action.addBsItem('beneficiary', cur)
              } else if (cur.stakeholders_type === '1') {
                action.addBsItem('holdingname', cur)
              } else if (cur.stakeholders_type === '0' && hasAgency) {
                action.addBsItem('agency', cur)
              }
              return bsInfo
            }, bsInfo)
          }
          // 兼容老版本
          if (bsInfo['beneficiary'].length === 0 && accountInfo.myselfisbfcy !== '1' &&
            accountInfo.beneficiary && accountInfo.beneficiary !== accountInfo.customerappellation) {
            action.addBsItem('beneficiary', {
              valid: false,
              bs_name: accountInfo.beneficiary
            })
          }
           //else {
            //$(".beneficiary-period-change").text("本人")
          //}
          if (bsInfo['holdingname'].length === 0 && accountInfo.myselfiscontorler !== '1' &&
            accountInfo.holdingname && accountInfo.holdingname !== accountInfo.customerappellation) {
            action.addBsItem('holdingname', {
              valid: false,
              bs_name: accountInfo.holdingname
            })
          }
          //else {
            //$(".holdingname-period-change").text("本人")
          //}
          // 代理人 未成年人默认增加一项
          if (hasAgency && bsInfo['agency'].length === 0) {
            action.addBsItem('agency')
          }
          $("#agency-change").data("ready", "1")
        } else {
          $.hsf.callFailProcess(jsonResult);
        }
      })
    },
    getDictFromSelect: function (selector) {
      return $(selector + " > option").map(function (index) {
        var option = $(selector + " > option").eq(index);
        return {
          key: option.attr("value"), value: option.text()
        }
      }).get()
    },
    transAddressToCode: function (addressArr, id) {
      var provinceDictData = action._private.provinceDictData;
      var indexArr = [];
      var valueArr = [];
      var captionArr = [];
      var type = 'no';
      var province, city;
      var useIndexOf = typeof addressArr == 'string'
      var matchTrue = function (a, index) {
        if (useIndexOf) {
          return addressArr.indexOf(a) === 0
        } else {
          return a == addressArr[index];
        }
      }
      if (id == 'bs_livecity' || (id === 'liveCity') && useIndexOf) type = 'name'
      for (var index = 0; index < provinceDictData.length; index++) {//翻译省代码
        if (matchTrue(provinceDictData[index]['provice' + type], 0)) {
          province = provinceDictData[index];
          indexArr.push(index);
          captionArr.push(province.provicename)
          valueArr.push(province.proviceno)
          if (useIndexOf) {
            addressArr = addressArr.substring(province.provicename.length);
          }
          break;
        }
      }
      if (!valueArr[0]) return;
      if (addressArr[1]) {//如果市是空,判断市码是否有效
        var pCities = province.cities.list ? province.cities.list : province.cities
        for (var index = 0; index < pCities.length; index++) {//翻译市代码
          if (matchTrue(pCities[index]['city' + type], 1)) {
            city = pCities[index];
            indexArr.push(index);
            captionArr.push(city.cityname)
            valueArr.push(city.cityno)
            if (useIndexOf) {
              addressArr = addressArr.substring(city.cityname.length);
            }
            break;
          }
        }
      }
      if (valueArr[1] && addressArr[2]) {//判断区码是否有效
        var pContries;
        if (city.counties) {
          pContries = city.counties;
        } else {
          pContries = city.contries.list ? city.contries.list : city.contries
        }
        for (var index = 0; index < pContries.length; index++) {////翻译区代码
          if (!pContries[index]['country' + type]) {
            pContries[index]['countryno'] = pContries[index]['countyno']
            pContries[index]['countryname'] = pContries[index]['countyname']
          }
          if (matchTrue(pContries[index]['country' + type], 2)) {
            var country = pContries[index];
            indexArr.push(index);
            captionArr.push(country.countryname)
            valueArr.push(country.countryno)
            if (useIndexOf) {
              addressArr = addressArr.substring(country.countryname.length);
            }
            break;
          }
        }
      }
      action._private.dictValues[id] = {
        index: indexArr,
        value: valueArr,
        caption: captionArr
      }
      var pcity = captionArr.join("");
      if (captionArr[0] === captionArr[1] && !captionArr[2]) {
        pcity = captionArr[0];
      }
      $("#" + id).find(".picker-value").text(pcity).removeClass(action._private.zdOptions.pickerUnSelectColor)
      // 如果城市为非境外但国家未选择，默认为中国
      if (id === 'liveCity' && valueArr[0] !== '99' && !action._private.dictValues['liveNation']) {
        action.initDictValue('liveNation', 'nationDict', '156')
      }
      if (useIndexOf) {
        $("#liveAddress").UITextField("value", addressArr)
      }
    },
    getParams: function (key) {
      return $.hsf.hsTools.getParamFromStr(window.location.hash.split("?")[1], key)
    }
  }
  $.extend({
    zdlegal: action
  })
}
if ("function"==typeof define&&define.amd) {
  define("zdlegal", ['jquery', "qselect", 'doT'], function ($, QSelect, doT) {
    // 为了兼容性做的处理，但会暴露在全局
    window.QSelect = QSelect;
    window.doT = doT;
    zdlegalModule($)
  })
} else {
  (function ($) {
    zdlegalModule($)
  })(jQuery)
}
