define([$.hsf.platform()],function (platform,require) {
	var platformApi = $.hsf.getModuleAPI(platform,"account-addAcco-tl-validate");
	var action={
		_private:{
			accoreqserial:""
		},
		$banklist : $("#bankList"),
		init : function() {
			action.loadUserInfo();
			action.packForm();
			action.sandclock = action.sandclock("smscodebtn");
			this.validForm = $.validForm();
			this.formGenerate = $.formGenerate();
			action.events()
			$.hsf.Event.addListener("selectBank", function(selectBankIndex) {
				action._private.selectCard = selectBankIndex;
				action.selectBankProcess(selectBankIndex);
			});
		},
		events:function(){
			$("#bankcardSelect").bind("tap",function () {
				action.popupBankcard();
				return false;
			})

			$("#smscodebtn").bind("tap",function () {
				action.sendBankAuthcode();
				return false;
			})

			$("#submitBtn").bind("tap",function () {
				action.next();
				return false;
			})


			$("#backMain").bind("tap",function () {
				$("#first").show();
				$("#third").hide();
				return false;
			});

			action.$banklist.UITableView("mark", function(result) {
				$.hsf.Event.trigger("selectBank", null, result);
				// $.hsf.hsBack()
				$("#first").show();
				$("#third").hide();
				return false;
			});
		},
		loadUserInfo : function(){
			$.hsf.startLoading();
			$.hsf.ajax.app("atomicquery/account/logininfo","","checkLoginCode",function(jsonResult){
				if (jsonResult.successful) {
					action._private.identityno = jsonResult.result.idno;
					action._private.identitytype = jsonResult.result.idtype;
					action._private.customername = jsonResult.result.customerappellation;
					$("#custname").html(jsonResult.result.customerappellation);
					$.hsf.stopLoading();
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		packForm : function() {
			var that = this;
			$.hsf.ajax.app("account/tradeacco/addCardForm","","bankcardFormCallback", function (jsonResult) {
				if (jsonResult.successful) {
					var bankcardsList = jsonResult.bankcards;
					action._private.bankcards = bankcardsList;
					$bankList = $("#bankList");
					$.doTemplate("bankList-tempalte", bankcardsList);
					$bankList.UITableView("refresh");
					if (bankcardsList.length == 0) {
						$.UIAlert("没有可增开的卡", function() {
							$.hsf.hsBack();
						});
					} else {
						action.selectBankProcess(0);
					}
				}
				else if (jsonResult.code == "ETS-1B405") {
					$.UIAlert("亲，您是新注册用户，请在两个工作日后再增开银行卡哦~", function() {
						$.hsf.hsBack();
					});
				}
				else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		getSelectBankcard : function() {
			return action._private.bankcards[action.constant.selectCard];
		},

		popupBankcard : function() {
			// window.location.hash = "account-addAcco-tl-validate-3";

			$("#third").show();
			$("#first").hide();
			return false;
		},

		selectBankProcess : function(result) {
			$(".selectedBankName").html(action._private.bankcards[result].bankname);
			$(".selectedBankcardIcon").removeAttr("class").addClass("selectedBankcardIcon bank-logo bank-"+action._private.bankcards[result].alias);
			action._private.capitalmode = action._private.bankcards[result].capitalmode;
			action._private.bankserial = action._private.bankcards[result].bankserial;
			action._private.bankname = action._private.bankcards[result].bankname;
		},

		//银行特殊处理获取验证码
		sendBankAuthcode:function(){
			if (action.sandclock.readyStart()) {
				var that = this;
				var mobile = $("#mobile").UITextField("value").trim();
				var identitytype = action._private.identitytype;
				var identityno = action._private.identityno;
				var bankacco=$("#bankacco").UITextField("value").trim();
				var customername = action._private.customername
				this.validForm.add("mobile", mobile);
				"0"==identitytype && this.validForm.add("cerfiticate", identityno);
				this.validForm.add("empty", bankacco, "银行编号");
				this.validForm.add("empty", custname, "姓名");
				this.validForm.add("empty", action._private.bankserial , "请选择银行卡");
				if (this.validForm.valid()) {
					var g = this.formGenerate;
					//g.add("mobile", mobile);
					g.add("identitytype", identitytype);
					g.add("identityno", identityno);
					g.add("capitalmode", action._private.capitalmode);
					g.add("customername", customername);
					g.add("bankserial", action._private.bankserial);
					g.add("mobile", mobile);
					g.add("bankacco", bankacco);
					if (action._private.capitalmode == "4") {
						g.add("bgSign", "1");
					}
					$.hsf.startLoading("正在获取...");
					$.hsf.ajax.app("account/mobile/fastSendCode", g.generate(), "sendbankauthcodeCallback", function(jsonResult) {
						$.hsf.stopLoading();
						if (jsonResult.successful) {
							action._private.accoreqserial = jsonResult.accoreqserial || "";
							action._private.bgSign = (jsonResult.bgSign == "1" ? "1" : "0");
							action._private.otherserial = jsonResult.otherserial;
							$.UIAlert("手机验证码已发送！请注意查收短信！");
							action.sandclock.start();
						} else {
							$.hsf.callFailProcess(jsonResult);
						}
					});
				}
			}
		},

		next:function() {
			// var that = this;
			var bankacco = $.trim($("#bankacco").UITextField("value"));
			var identitytype = action._private.identitytype;
			var identityno =action._private.identityno;
			var mobile = $("#mobile").UITextField("value").trim();
			var customername = action._private.customername;
			var authcode = $("#authcode").UITextField("value").trim();
			"0"==identitytype && this.validForm.add("cerfiticate", identityno);
			this.validForm.add("empty", bankacco, "请输入银行卡号");
			this.validForm.add("mobile", mobile);
			this.validForm.add("empty", authcode, "请输入验证码");
			if(action._private.capitalmode!="4"){// capitalmode 卡为
				this.validForm.add("empty", action._private.accoreqserial, "请重新获取验证码");
			}
			if (this.validForm.valid()) {
				var g = this.formGenerate;
				g.add("mobile", mobile)
				.add("identitytype", identitytype)
				.add("identityno", identityno)
				.add("capitalmode", action._private.capitalmode)
				.add("customername", customername)
				.add("custname", customername)
				.add("bankserial", action._private.bankserial)
				.add("bankacco", bankacco)
				.add("mobileauthcode", authcode)
				.add("busintype", "OPENTRADEACCO");
				g.add("accoreqserial", action._private.accoreqserial)
                    .add("originalorderid", action._private.accoreqserial);
                if (action._private.capitalmode == "4") {
                  g.add("bgSign", action._private.bgSign);
                  g.add("otherserial",action._private.otherserial)
                }
				$.hsf.startLoading("正在验证...");//首先验证手机验证码
				$.hsf.ajax.app("account/bank/fastAuthor", g.generate(), "validateSignatureCallback", function(jsonResult) {
					$.hsf.stopLoading();
					if(jsonResult.successful) {
						action.merOpenAcco(jsonResult);
					} else if (jsonResult.code == "ETS-1BQ08") {
						$.UIAlert("您的验证码已失效 ,请重新获取");
					} else {
						$.hsf.callFailProcess(jsonResult);
					}
				})
			}
			return false;
		},
		merOpenAcco:function(fastAuthResult) {
			$.hsf.startLoading("正在提交...");
			var that = this;
			var bankacco = $.trim($("#bankacco").UITextField("value"));
			var identitytype = action._private.identitytype;
			var identityno =action._private.identityno;
			var mobile = $("#mobile").UITextField("value").trim();
			var customername = action._private.customername;
			var bankname = action._private.bankname;
			var g = this.formGenerate;
			g.add("bankacco", bankacco)
			.add("bankserial", action._private.bankserial)
			.add("bankname", bankname)
			.add("bankacconame", customername)
			.add("capitalmode", action._private.capitalmode)
			.add("detailcapitalmode", "01")
			.add("customerappellation", customername)
			.add("identityno", identityno)
			.add("identitytype", identitytype)
			.add("mobile", mobile)
			.add("accoreqserial", action._private.accoreqserial)
			.add("interfacetype", "1")
              .add("yinliancdcard", fastAuthResult.yinliancdcard);
			$.hsf.ajax.app("account/tradeacco/addCard", g.generate(), "merOpenCallback", function(jsonResult) {
				if(jsonResult.successful) {
					$.hsf.stopLoading();
					$("#forth").show();
					$("#first").hide();
					platformApi.addBankcardSucc && platformApi.addBankcardSucc();
					return false
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		sandclock :  function(id) {
			var counter = 0;
			var $btn = $("#"+id);
			return {
				start : function() {
					var run = function() {
						if (counter == 0) {
							$btn.attr("m-state","").html("获取");
						} else {
							$btn.html("剩余"+(counter--)+"秒");
							setTimeout(run, 1000);
						}
					}
					counter = 60;
					$btn.attr("m-state","disabled").html("剩余"+(counter--)+"秒");
					setTimeout(run, 1000);
				},
				readyStart : function() {
					if (counter == 0) {
						return true;
					} else {
						false;
					}
				}
			}
		}
	};
	return action;
})
