define([], function() {
  var bankname = $.hsf.hsTools.getParam('bankname');
  var bankacco = $.hsf.hsTools.getParam('bankacco');
  var capitalmode = $.hsf.hsTools.getParam('capitalmode');
  var custname = $.hsf.hsTools.getParam('custname');
  var idtype = $.hsf.hsTools.getParam('idtype');
  var idno = $.hsf.hsTools.getParam('idno');
  var mobile = $.hsf.hsTools.getParam('mobile');
  var bgSign = "";
  if(!!mobile){
	  mobile = mobile.replace("86|","");
  }
  var tradeacco = $.hsf.hsTools.getParam('tradeacco');
  var bankserial = $.hsf.hsTools.getParam('bankserial');
  var accoreqserial = '';
  var yinliancdcard = '';
  var action = {
    init: function() {
      this.sandclock = this.sandclock('smscodebtn');
      this.formGenerate = $.formGenerate();
      this.validForm = $.validForm();
      $('#custname').html(custname);
      $('#bankname').html(bankname);
      $('#bankacco').html($.hsf.hsTools.maskCardCenter(bankacco));
      $('#handset').html(mobile);

      action.events();
      action.getUserInfo();

    },
    getUserInfo: function() {
      $.hsf.startLoading();
      $.hsf.ajax.app('atomicquery/account/logininfo', '', 'userInfoCallback',
        function(jsonResult) {
          if (jsonResult.successful) {
            $.hsf.stopLoading();
            // global.idType;
            custname = jsonResult.result.customerappellation;
            idtype = jsonResult.result.idtype;
            idno = jsonResult.result.idno;
            mobile = jsonResult.result.handset;
			if(!!mobile){
			    mobile = mobile.replace("86|","");
			}
            $('#custname').html(custname);
            $('#bankname').html(bankname);
            $('#bankacco').html(bankacco);
            $('#handset').html(mobile);
          } else {
            $.hsf.callFailProcess(jsonResult);
          }
        });
    },
    events: function() {
      $('#smscodebtn').bind('tap', function() {
        action.sendBankAuthcode();
      });
      $('#submitBtn').bind('tap', function() {
        action.fastAuthor();
      });
    },
    sandclock: function(id) {
      var counter = 0;
      var $btn = $('#' + id);
      return {
        start : function() {
          var run = function() {
            var timestamp2=(new Date()).valueOf();
            var timeInterval = Math.round((timestamp2 - timestamp)/1000);
            if (counter <= timeInterval) {
              counter = 0;
              $btn.attr("m-state","").html("获取验证码");
              $btn.css('background','#ec222e');
            } else {
              $btn.html((counter-timeInterval)+"秒后重发");
              setTimeout(run, 1000);
            }
          }

          counter = 90;
          var timestamp=(new Date()).valueOf();

          $btn.attr("m-state","disabled").html("剩余"+(counter--)+"秒");
          $btn.css('background','#999');
          setTimeout(run, 1000);
        },
        readyStart: function() {
          if (counter === 0) {
            return true;
          } else {
            false;
          }
        },
        reset: function() {
          counter = 0;
          $btn.attr('m-state', '').html('获取验证码');
          $btn.css('background', '#ec222e');
        },
      };
    },
    //银行特殊处理获取验证码
    sendBankAuthcode: function() {
      if (action.sandclock.readyStart()) {
        var that = this;
        var g = this.formGenerate;
        g.add('mobile', mobile);
        g.add('capitalmode', capitalmode);
        g.add('customername', custname);
        g.add('renewsign', 'true');
        g.add('tradeacco', tradeacco);
        if (capitalmode == 'AD') {
          g.add('sendintent', 'openacco');
          g.add('way', 0);
          g.add('isauthcodereturn', 1);
        }
        if (capitalmode == "4") {
          g.add("bgSign","1");
        }
        $.hsf.startLoading('正在获取...');
        $.hsf.ajax.app('account/mobile/fastSendCode', g.generate(), 'sendbankauthcodeCallback', function(jsonResult) {
          $.hsf.stopLoading();
          if (jsonResult.successful) {
            accoreqserial = jsonResult.accoreqserial || "";
            bgSign = (jsonResult.bgSign=="1"?"1":"0");
            $.UIAlert('手机验证码已发送！请注意查收短信！');
            that.sandclock.start();
          } else if (jsonResult.code === '0754') {
            $.UIPopup('银行卡号输入有误，请重新输入');
          } else {
            $.hsf.callFailProcess(jsonResult);
          }
        });
      }
    },
    //验证验证码
    fastAuthor: function() {
      $('[m-role=\'UITextField\'] input').blur();
      var authcode = $('#authcode').UITextField('value').trim();
      this.validForm.add('empty', authcode, '请输入验证码');
      if (this.validForm.valid()) {
        var g = this.formGenerate;
        g.add('mobile', mobile).
            add('accoreqserial', accoreqserial).
            add('capitalmode', capitalmode).
            add('customername', custname).
            add('renewsign', 'true').
            add('tradeacco', tradeacco).
            add('originalorderid', accoreqserial).
            add('mobileauthcode', authcode).
            add('busintype', 'OPENTRADEACCO');
          if (capitalmode == "4") {
            g.add("bgSign", bgSign);
          }
        $.hsf.startLoading('正在验证...');//首先验证手机验证码
        $.hsf.ajax.app('account/bank/fastAuthor', g.generate(), 'validateSignatureCallback', function(jsonResult) {
          $.hsf.stopLoading();
          if (jsonResult.successful) {
            yinliancdcard = jsonResult.yinliancdcard;
            //如果成功了,这里进行鉴权。
            action.signAndCancelBank();
          } else if (jsonResult.code == 'ETS-1BQ08') {
            $.UIPopup('请重新获取验证码');
          } else if (jsonResult.code == '0754' || jsonResult.code == 'ETS-5BP99999') {
            $.UIPopup('用户信息输入有误，请核对后重新输入');
          } else {
            $.hsf.callFailProcess(jsonResult);
          }
        });
      }
      return false;
    },
    signAndCancelBank: function() {
      var data = 'custname=' + custname
        + '&capitalmode=' + capitalmode
        + '&bankserial=' + bankserial
        + '&mobile=' + mobile
        + '&tradeacco=' + tradeacco
        + '&accoreqserial=' + accoreqserial
        + '&operator=0'
        + '&sendintent=opentradeacco'
        + '&yinliancdcard=' + yinliancdcard
        + '&interfacetype=1'
        + '&busintype=OPENTRADEACCO';
      $.hsf.ajax.app('account/tradeacco/signAndCancelBank', data,
        'signAndCancelBankCallback', function(jsonResult) {
          if (jsonResult.successful) {
            $.UIAlert(jsonResult.message, function() {
              //发送签约成功的通知，更新银行卡状态。
              if ($.hsf.matchNative()) {
                $.platform.refreshBankcardStatus();
              }
              $.hsf.hsBack();
            });
          } else {
            $.hsf.callFailProcess(jsonResult);
          }
        });
    },
  };
  return action;
});