define([], function () {
    var action = {
        _private: {
            loginSucc: false,
            loginInfo:{},
        },
        init: function () {
            $.platform.initPage && $.platform.initPage();
            action.getUserInfo();
            $.hsf.Event.addListener("login", function() {
                action.getUserInfo();
            });
            if($.hsf.matchAndroid()){
                $.platform.nativeVersion(function (nativeVersion) {
                    $("#app-version").text(nativeVersion);
                });
            }
            action.events();
        },
        renderProfessionInfo:function(userinfo){
            var pflag = userinfo.result.pubprofessionflag,
                psubtype = userinfo.result.pubprofessionsubtype,
                pvaliddate = userinfo.result.pubprofessionvaliddate,
                pflagstr = pflag === "1"?"(专业投资者)":"(普通投资者)";
                var $el = $("#personInfo").show();
                $el.find("#username").html(userinfo.result.customerappellation+pflagstr).show();
                $el.find("#avatar").attr("m-href","investment-suitability.html?flag=a&hsback=1");
                if(pflag === "1" && psubtype){//专业投资者显示等级
                    var psubtypestr = psubtype+"类投资者";
                    if((psubtype === "G" || psubtype === "E")&&pvaliddate){//DE判断过期时间
                        var now = new Date();
                        pvaliddate = pvaliddate.replace(/^(\d{4}).?(\d{2}).?(\d{2})$/,"$1/$2/$3");
                        if(now - new Date(pvaliddate) > 0){
                            psubtypestr = "专业等级已过期";
                        }
                    }
                    $el.find("#psubtypestr").html(psubtypestr);
                }else{
                    $el.find("#psubtypestr").html("");
                }
        },
        getUserInfo: function () {
            $.hsf.startLoading();
            $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack", function (jsonResult) {
                $.hsf.stopLoading();
                if (jsonResult.successful) {
                    action._private.loginSucc = true;
                    action._private.loginInfo=jsonResult.result;
                    $("#signin").hide();
                    $("#checkOut").show();
                    $("#username").html(jsonResult.result.customerappellation);
                    $.hsf.hsTools.needInvestmentSuitability(function(){
                        action.renderProfessionInfo(jsonResult)
                    });
                } else {
                    action._private.loginSucc = false;
                    $("#signin").show();
                    $("#checkOut").hide();
                    $("#avatar").attr("m-href",null);
                    if($.hsf.matchAndroid()){
                        // 这里不加的话 手势偶现显示不了姓名的问题。
                        $.hsf.callFailProcess(jsonResult);
                    }
                }
            });
        },
        loginOut: function () {
            $.hsf.startLoading();
            $.hsf.ajax.app("account/login/logout", "", "logoutCallBack", function (jsonResult) {
                if (jsonResult.successful) {
                    action._private.loginSucc = false;
                    //$.platform.removeCache("token");
                    //$.platform.removeCache("gestureStatus");
                    $.platform.removeCache("userInfo");
                    $.platform.removeCache("loginInfo");
                    $.platform.removeCache("fundlist");
                    $.platform.removeCache("fundlistDate");
                    $.platform.logoutRefresh && $.platform.logoutRefresh();
                    $.platform.removeCache("token");
                    $.platform.removeCache("gestureStatus");
                    if($.hsf.matchAndroid()){
                        $.platform.triggerLogout && $.platform.triggerLogout();
                        $.platform.removeAllCache();
                    }
                    setTimeout( $.hsf.stopLoading(), 500);
                    if($.hsf.platform()=="platform/pcapi"||$.hsf.platform()=="platform/weixinapi"){
                        setTimeout( $.hsf.hsOpen("index.html"), 500);
                    }else if($.hsf.platform()=="platform/iosapi"||$.hsf.platform()=="platform/androidapi"){
                        setTimeout( $.hsf.hsOpen("index.html"), 500);
                    }
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        events: function () {
            $("#signin").on('tap', function () {
                action.login();
            });
            $("#checkOut").on('tap', function () {
                if($.hsf.platform()=="platform/pcapi"||$.hsf.platform()=="platform/weixinapi"){
                    action.loginOut();
                }else if($.hsf.platform()=="platform/iosapi"||$.hsf.platform()=="platform/androidapi"){
                    $.UIConfirm({"html": "是否安全退出?", "submitText": "确定", "cancelText": "取消"}, function(v) {
                        if(v == "yes"){
                            action.loginOut();
                        }
                    });
                }
            });
            //设置
            $("#setting").on('tap',function(){
                if (action._private.loginSucc) {
                    $.hsf.hsOpen("account-setting.html");
                } else {
                    $.hsf.innerLogin();
                }
                return false;
            });
            //帐户管理
            $("#accountSetting").on('tap', function () {
                if (action._private.loginSucc) {
                    $.hsf.hsOpen("account-info.html");
                } else {
                    $.hsf.innerLogin();
                }
                return false;
            });
            //我的定投
            $("#myAvgr").on('tap', function () {
                if (action._private.loginSucc) {
                    $.hsf.hsOpen("regular-buy-list.html");
                } else {
                    $.hsf.innerLogin();
                }
                return false;
            });
            $("#checkVersion").on("tap",function () {
                if($.hsf.matchAndroid()){
                    $.platform.nativeVersion(function (nativeVersion) {
                        $.hsf.ajax.app("system/common/lastVersion", "platform=android&clientVersion="+nativeVersion, "logoutcallback", function(jsonResult) {
                            $.hsf.stopLoading();
                            if(jsonResult.successful) {
                                var version = jsonResult.versionResult.version;//3位版本号，例如5.6.12
                                $("#app-version").text(nativeVersion);
                                if(nativeVersion != version){
                                    version = version.substring(0,version.lastIndexOf("."));
                                    if( parseFloat(nativeVersion)<parseFloat(version)){
                                        $.UIPopup("当前版本不是最新版本，请更新最新版本！");
                                    }else{
                                        $.UIPopup("当前已是最新版本！");
                                    }
                                }else{
                                    $.UIPopup("当前已是最新版本！");
                                }
                            } else {
                                $.hsf.callFailProcess(jsonResult);
                            }
                        });
                        return false;
                    });
                }else{
                    $.platform.checkVersion && $.platform.checkVersion("1");
                }
                return false;
            });
            $("#chatonline").on("tap", function () {
               var accountType = action._private.loginInfo.idtype||"0";
                var identityno =action._private.loginInfo.idno;
                var mobile = action._private.loginInfo.handset;
                var name = action._private.loginInfo.customerappellation;
                $.hsf.goOnlineService(name,mobile,accountType,identityno); //在线客服
              return false;
            });
        },
        login: function () {
            $.hsf.innerLogin();
            return false;
        }
    };
    return action;
});
