define(["global", "Backbone"], function () {
    return Backbone.View.extend({
        el: "#asset",
        parent: null,
        title: {
            left: {
                show: false
            },
            center: {
                text: "资产"
            },
            right: {
                show: false
            },
            border: {
                show: false
            }
        },
        initialize: function (parent, platformApi) {
            $("body").removeClass('m-bg-white');
            if($.hsf.matchNative()){
                // 广播后页面刷新
                $.platform.addListener("refreshAccount",function(){
                    window.location.reload();
                    return false;
                });
            }
            var that = this;
            this.parent = parent;
            this.platformApi = platformApi;

            $.hsf.Event.addListener("login", function () {
                that.requestManager.invoke(that.initAsset);
            });
            this.requestManager = $.hsf.requestManager(this);
            this.requestManager.add(this.initAsset, 30 * 60);
            this.platformApi.initPage(this);
        },
        // initAlert:function(){
        //     $.hsf.startLoading();
        //     $.hsf.ajax.app('wxzt/m', 'functionCode=1051&originalId=app', 'initAlertCallback', function (jsonResult) {
        //         if (jsonResult && 'ETS-5BP0000' == jsonResult.code) {
        //             var message = JSON.parse(jsonResult.message);
        //             $.hsf.stopLoading();
        //             $.platform.getCache('openAlertWindow', function(result) {
        //                 alert(JSON.stringify(result))
        //                 if (result != 'done') {
        //                     $.UIAlertEx(message.result.list &&
        //                         message.result.list[0].content);
        //                     // 将按钮改成知道了文字
        //                     $('.UIAlertSubmit').text('知道了');
        //                     $.platform.putCache('openAlertWindow', 'done');
        //                 } else {
        //                 }
        //             });
        //         } else {
        //             $.hsf.stopLoading();
        //         }
        //     })
        // },
        initAsset: function () {
            var platformApi = $.hsf.platform()
            if (platformApi == 'platform/pcapi' || platformApi == 'platform/weixinapi') {
                $('#messaage').hide()
            } else if (platformApi == 'platform/iosapi' || platformApi == 'platform/androidapi') {
                $('#messaage').attr('m-href', 'news-list.html')
                $('#messaage').show()
            }

            var that = this;
            this.parent.lockNavigate();//锁导航栏
            $.hsf.startLoading();
            $.hsf.ajax.app("query/share/getTotalShareList", "", "standShareList", function (jsonResult) {
                if (jsonResult.successful) {
                    that.loadAssetlist(jsonResult);
                    that.parent.unlockNavigate();
                    $.hsf.stopLoading();
                } else {
                    that.requestManager.resetTime(that.initAsset);
                    $.hsf.callFailProcess(jsonResult, function () {
                        that.parent.unlockNavigate();
                    });
                }
            });
        },
        resetPage: function () {
            $.doTemplate('renderArea', null, "recover");
            this.requestManager.resetTime(this.initAsset);
        },
        loadAssetlist: function (jsonResult) {
            $.doTemplate('asset-title', jsonResult, "refresh");
            $.doTemplate('asset-body', jsonResult.shareList,"refresh");
            $("#assetList").UITableView("refresh");
        },
        packZc: function (jsonResult) {
            var ccsy = jsonResult.totalIncome, positonGainArrow = $("#position-gain-arrow"),
                buyBtn = $(".zc-total-buy-link");
            if (jsonResult.holdingIncome && parseFloat(jsonResult.holdingIncome) <= 0) {// 判断持仓收益是否为0
                positonGainArrow.hide();
            } else {
                positonGainArrow.show();
            }
            if (jsonResult.totalMarketvalue && parseFloat(jsonResult.totalMarketvalue) >= 0) {// 判断总资产是否为0
                buyBtn.show();
            } else {
                buyBtn.hide();
            }
        },
        events: {
            "tap .zc-list-more": "openOper",
            "tap .close-btn": "closeOper"
        },
        gotoBuy: function (e) {
            $.hsf.hsOpen("fund-list.html");
        },
        openOper: function (e) {
            var _this = e.currentTarget;
            $(".on").removeClass("on");
            $(_this).next().addClass('on');
            e.stopPropagation();
            return false;
        },
        closeOper: function (e) {
            var _this = e.currentTarget;
            var opt = $(_this).parent().removeClass('on');
            return false;
        },
        fontResize: function () {
            $(".font-resize").each(function () {
                var self = $(this), txt = self.text().replace(/(\,|\.)/g, ""),
                    numLength = txt.length;
                numLength = parseInt(numLength, 10);
                if (numLength > 9) {
                    self.css('font-size', "12px");
                } else if (numLength == 9) {
                    self.css('font-size', "14px");
                } else {
                    self.css('font-size', "16px");
                }
            });
        },
        afterSwitchView: function () {
            $("body").removeClass('m-bg-white');
            this.initAsset()
        },
        ddHtml: "<dd m-selectionstyle='no'><div m-role='cell' m-layout='fit' m-mode='y' class=''><div m-role='cell' class='padding-10 border-b' m-href=''><div m-role='cell' m-valign='middle' m-layout='fit'><span class='fundname'></span><span class='m-font-10 m-font-light fundcode' m-margin='0 0 0 1'></span></div><div m-role='cell' class='m-font-10 m-font-light funddate'></div></div><div m-role='cell' class='zc-list-item' m-selectionstyle='yes' m-href=''><div m-role='cell' m-mode='y' m-layout='fit' class='padding-t-10 padding-b-10 padding-l-10'><div m-role='cell' m-margin='0 0 1 0' class='m-font-10 m-font-light'>资产市值</div><div m-role='cell' class='m-color-red  marketvalue'></div></div><div m-role='cell' m-mode='y' m-layout='fit' class='padding-t-10 padding-b-10'><div m-role='cell' m-margin='0 0 1 0' class='m-font-10 m-font-light'>当日收益</div><div m-role='cell' class='m-color-red todayIncome'></div></div><div m-role='cell' m-mode='y' m-layout='fit' class='padding-t-10 padding-b-10'><div m-role='cell' m-margin='0 0 1 0' class='m-font-10 m-font-light'>累计收益</div><div m-role='cell' class='m-color-red totalIncome'></div></div><div m-role='cell' m-mode='y' m-valign='middle' class='zc-list-more w30 ' m-selectionstyle='yes'><div class='gray-dot' m-margin='0 0 1 0'></div><div class='gray-dot' m-margin='0 0 1 0'></div><div class='gray-dot'></div></div><div m-role='cell' m-mode='x' class='zc-list-opt'><div m-role='cell' m-mode='x-equal' m-layout='fit'><div m-role='cell' m-align='center' m-valign='middle' class='zc-list-btn m-color-blue tradesale' m-selectionstyle='yes' m-href='trade-sale.html'>赎回</div><div m-role='cell' m-align='center' m-valign='middle' class='zc-list-btn m-color-blue m-bg-ec tradetrans' m-selectionstyle='yes' m-href='trade-trans.html'>转换</div></div><div m-role='cell' class='m-bg-e3 close-btn w40' m-valign='middle' m-align='center' m-selectionstyle='yes'><div m-icon='close'></div></div></div></div></div></dd>"


    });
});
