define(['loadSwiper'], function (m) {
    //var echarts = m;
    var action = {
        constant: {
            fundcode: $.hsf.hsTools.getParam("fundcode"),
            fundname: $.hsf.hsTools.getParam("fundname"),
            fundtypestr: $.hsf.hsTools.getParam("fundtypestr"),
            page: 1,
            isMoved: false,
            loadedComplete:false
        },
        init: function () {
            $("#fundcode").html(action.constant.fundcode);
            $("#fundname").html(action.constant.fundname);
            $("#fundtype").html(action.constant.fundtypestr);
            $("#fundtype").addClass("tit-tag");
            action.events();
            action.getHisMarket("time_4");
            action.loadBox();
        },
        getHisMarket: function (id) {
            var that = this;
            var queryuint = "";
            var recordno = 0;

            if (id == "time_1") {
                queryuint = 1;
                recordno = 30;
            } else if (id == "time_2") {
                queryuint = 3;
                recordno = 90;
            } else if (id == "time_3") {
                queryuint = 6;
                recordno = 180;
            } else if (id == "time_4") {
                queryuint = 12;
                recordno = 20;
            }
            var data = "fundcode=" + action.constant.fundcode + "&queryunit=" + queryuint + "&pageno=" + action.constant.page + "&applyrecordno=" + recordno + "&datasource=DC";
            $.hsf.startLoading();
            $.hsf.ajax.app("atomicquery/fundinfo/hisMarket", data, "chartCallback" + queryuint, function (jsonResult) {

                if (jsonResult.successful && jsonResult.returnList && jsonResult.returnList.length > 0) {
                    if (jsonResult.returnList && jsonResult.returnList.length > 0) {

                        for (var i = 0; i < jsonResult.returnList.length; i++) {
                            if (jsonResult.returnList[i].dayinc > 0) {
                                jsonResult.returnList[i].dayinc = (("0" + jsonResult.returnList[i].dayinc.substr(1, jsonResult.returnList[i].dayinc.length)) * 100).toFixed(2);
                            } else if(jsonResult.returnList[i].dayinc == 0){
                                jsonResult.returnList[i].dayinc= "0.00";
                            }else{
                                jsonResult.returnList[i].dayinc = (("-0" + jsonResult.returnList[i].dayinc.substr(2, jsonResult.returnList[i].dayinc.length)) * 100).toFixed(2);
                            }
                            jsonResult.returnList[i].totalnetvalue = parseFloat(jsonResult.returnList[i].totalnetvalue).toFixed(4);
                        }
                    }
                    jsonResult.returnList.fundtype = jsonResult.fundtype;
                    $.doTemplate('rel_1_area', jsonResult.returnList);
                    action.constant.page++;
                    if(jsonResult.returnList.length<20){
                        action.constant.loadedComplete = true;
                    }
                    $.hsf.stopLoading();
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        events: function () {
        },
        loadBox: function () {
            //action.constant.page = 1;
            var loadingShow = false;
            var loadingStr = '<div class="spinner">' +
                '<div class="spinner-container container1">' +
                '<div class="circle1">' +
                '</div>' +
                '<div class="circle2">' +
                '</div>' +
                '<div class="circle3">' +
                '</div>' +
                '<div class="circle4">' +
                '</div>' +
                '</div>' +
                '<div class="spinner-container container2">' +
                '<div class="circle1">' +
                '</div>' +
                '<div class="circle2">' +
                '</div>' +
                '<div class="circle3">' +
                '</div>' +
                '<div class="circle4">' +
                '</div>' +
                '</div>' +
                '<div class="spinner-container container3">' +
                '<div class="circle1">' +
                '</div>' +
                '<div class="circle2">' +
                '</div>' +
                '<div class="circle3">' +
                '</div>' +
                '<div class="circle4">' +
                '</div>' +
                '</div>' +
                '</div>';
            var swiper = new Swiper('.swiper-container', {
                scrollbar: '.swiper-scrollbar',
                direction: 'vertical',
                slidesPerView: 'auto',
                mousewheelControl: true,
                freeMode: true,
                onTouchMove: function (swiper) {
                    //有滑动时才加载
                    action.constant.isMoved = true;
                },
                onTouchEnd: function (swiper) {
                    if (action.constant.isMoved && swiper.isEnd) {
                        action.constant.isMoved = false;
                        //完成一次loading才能开始下一次loading，防止重复多次
                        if (!loadingShow) {
                            //加载loading提示
                            if(!action.constant.loadedComplete){
                                swiper.appendSlide('<div class="swiper-slide">' + loadingStr + '</div>');
                                swiper.slideNext();
                                loadingShow = true;
                                getAjaxNews();
                            }else{
                                $.UIPopup("数据已全部显示。");
                            }
                        }
                    }
                }
            });

            function getAjaxNews() {
                var data = "fundcode=" + action.constant.fundcode + "&queryunit=12" + "&pageno=" + action.constant.page + "&applyrecordno=20" + "&&datasource=DC";
                $.hsf.startLoading();
                $.hsf.ajax.app("atomicquery/fundinfo/hisMarket", data, "chartCallback", function (jsonResult) {
                    if (jsonResult.successful) {
                        $.hsf.stopLoading();
                        if (jsonResult.returnList && jsonResult.returnList.length > 0) {


                            for (var i = 0; i < jsonResult.returnList.length; i++) {
                                if (jsonResult.returnList[i].dayinc > 0) {
                                    jsonResult.returnList[i].dayinc = (("0" + jsonResult.returnList[i].dayinc.substr(1, jsonResult.returnList[i].dayinc.length)) * 100).toFixed(2);
                                } else if(jsonResult.returnList[i].dayinc == 0){
                                    jsonResult.returnList[i].dayinc= "0.00";
                                }else{
                                    jsonResult.returnList[i].dayinc = (("-0" + jsonResult.returnList[i].dayinc.substr(2, jsonResult.returnList[i].dayinc.length)) * 100).toFixed(2);
                                }

                                jsonResult.returnList[i].totalnetvalue = parseFloat(jsonResult.returnList[i].totalnetvalue).toFixed(4);

                            }


                            //删除loading提示
                            swiper.removeSlide(action.constant.page-1);
                            loadingShow = false;
                            action.constant.page++;
                            if (jsonResult.returnList) {
                                var appendArr = [];
                                for (var i = 0; i < jsonResult.returnList.length; i++) {
                                    appendArr.push('<tr>','<td>' + jsonResult.returnList[i].navdate.substr(0, 4) + '/' + jsonResult.returnList[i].navdate.substr(5, 2) + '/' + jsonResult.returnList[i].navdate.substr(8, 2) + '</td>');
                                    if(jsonResult.fundtype != "2") {
                                        appendArr.push('<td>' + jsonResult.returnList[i].pernetvalue + '</td>','<td>' + jsonResult.returnList[i].totalnetvalue + '</td>');
                                        if (jsonResult.returnList[i].dayinc > 0) {
                                            appendArr.push('<td class="m-color-red">' + jsonResult.returnList[i].dayinc + '%</td></tr>');
                                        } else {
                                            appendArr.push('<td class="m-color-green">' + jsonResult.returnList[i].dayinc + '%</td></tr>');
                                        }
                                    }else{
                                        appendArr.push('<td>' + jsonResult.returnList[i].incomeratio + '%</td>');
                                        appendArr.push('<td>' + jsonResult.returnList[i].hf_incomeratio + '</td></tr>');
                                    }
                                }
                                var appendStr = appendArr.join("");
                                swiper.appendSlide('<div class="swiper-slide">' + '<table class="table-list m-font-12 table-list-1" style="table-layout:fixed">' + appendStr + '</table>' + '</div>');

                                swiper.slideNext();
                                if((action.constant.page-1)*20>=jsonResult.totalrecords){
                                    loadingShow = false;
                                    $.UIPopup("数据已全部显示。");
                                    action.constant.loadedComplete = true;
                                }
                            }

                        } else {
                            //删除loading提示
                            swiper.removeSlide(action.constant.page-1);
                            loadingShow = false;
                            $.UIPopup("数据已全部显示。");
                        }
                    } else {
                        $.hsf.callFailProcess(jsonResult);
                    }
                });
                swiper.params.onlyExternal = false;
            }
        }
    };
    return action;
});
