/**
 * 要求直销返回费率时 
 */
define(["global"], function() {
  return {
    constant: {
      fundinfo: {},
      fundcode: $.hsf.hsTools.getParam("fundcode"),
      fundname: $.hsf.hsTools.getParam("fundname"),
      businflag:"022"
    },
    init: function() {
      this.productDetail();
    },
    productDetail: function() {
      $.hsf.startLoading();
      var that = this;
      var data = $.formGenerate().add("fundcode", that.constant.fundcode).generate();
      $.hsf.ajax.app("product/product/productDetail", data, "productDetailCallBack", function(jsonResult) {
        if(jsonResult && jsonResult.successful) {
          that.constant.fundinfo = jsonResult.productDetailInfo;
          if (jsonResult.productDetailInfo.buybusin == "020") {
            $("#buy-type-n").html("T+n");
            $("#buy-type-text").html("T+n当日净值更新后")
            that.constant.businflag="020"
          }
          that.rateInterval();
          $.doTemplate('fundinfo', jsonResult.productDetailInfo);
        } else {
          $.hsf.callFailProcess(jsonResult);
        }
      });
    },
    rateInterval: function() {
      var that=this;
      var data = $.formGenerate()
        .add("fundcode", this.constant.fundcode)
        .add("custtype", "1") //1-个人
        .add("requestnum", "99") //一次查完，防止分页
        .add("sharetype","A")
        .generate();
      var that = this;
      return $.hsf.ajax.app("atomicquery/fundinfo/queryFundRate", data, "rateIntervalCallBack", function(jsonResult) {
        if(jsonResult && jsonResult.successful) {
          var feeobj,
            fundinfo = that.constant.fundinfo,
            redeemsymboolObj = {
              firstsymbool: '≤',
              leftsymbool: '&lt;',
              rightsymbool: '≤',
              lastsymbool: '&gt;'
            },
            newjsonResult = {
              declare: [],
              redeem: []
            };
          for(var i in jsonResult.returnList) {
            feeobj = jsonResult.returnList[i];
              if(feeobj.faretype == "0" && (feeobj.businflag == '022' || feeobj.businflag == '020') && feeobj.sharetype == "A" ) { //022-申购业务代码，0-直销
                newjsonResult.declare.push(feeobj);
                continue;
              }
            // console.log(newjsonResult)
            if(feeobj.faretype == "0" && feeobj.businflag == '024') { //024-赎回业务代码
              if(feeobj.minhold == 0 && (feeobj.maxhold % 7 == 0 || feeobj.maxhold % 30 == 0 || feeobj.maxhold % 365 == 0)) {
                redeemsymboolObj = {
                  firstsymbool: '&lt;',
                  leftsymbool: '≤',
                  rightsymbool: '&lt;',
                  lastsymbool: '≥'
                }
              }
              feeobj = $.extend(feeobj, redeemsymboolObj);
              newjsonResult.redeem.push(feeobj);
              continue;
            }
          }
          $.doTemplate('rateIntervalView', newjsonResult);
          $.doTemplate('otherfee', that.constant.fundinfo);
          if(that.constant.businflag=="020"){
              $("#businflag-type").show()
          }
          $.hsf.stopLoading();
        } else {
          $.hsf.callFailProcess(jsonResult);
        }
      });
    },
  };

});