/**
 * Created by wulz15390 on 2016/5/3.
 */
define([$.hsf.platform()],function(platform,require) {
    var platformApi = $.hsf.getModuleAPI(platform,"jinsp-buy");
    var action = {
        constant : {
            day : ["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],
            result : null,
            activeBankIndex: 0,
            counter:0,
            repeatSeconds: 10
        },
        init : function() {
            var that = this;
            platformApi.initPage && platformApi.initPage(action);
            $.hsf.hsTools.investmentSuitability(function (jsonResult) {
                that.packForm();
                that.event();
            });
        },
        packForm : function() {
            $.hsf.startLoading();
            $.hsf.ajax.app("moneyfund/charge/chargeForm", "antiMoneyBusinestype=090&warningchannel="+$.platform.warningchannel, "chargeFormCode", function(jsonResult) {
                if (jsonResult.successful) {
                    $.hsf.stopLoading();
                    $.hsf.hsTools.checkHgxForTrade(jsonResult,function(){     //检查合规性
                        action.constant.result = jsonResult;
                        action.packFirstPage(jsonResult);
                        // 工行快捷需要显示的文字提示是
                        jsonResult.bankCards = $.hsf.hsTools.toQuickStr(jsonResult.bankCards, "工行网银", "工商银行")
                        $.doTemplate('bankList', jsonResult.bankCards, "refresh");
                    });
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        packFirstPage : function(jsonResult) {
            $(".fundname").html("盛钱宝");
            $(".fundcode").html(jsonResult.fundcode);
            //$("#tip").html(jsonResult.riskmatchResult.riskmsg).UITip("show");
            action.renderAWarning(jsonResult);
            //if (jsonResult.buyLimitResult.limits.length > 0) {//客户需要显示现金宝的最小申购金额
            //    //action.changeApplySum(jsonResult.buyLimitResult.limits[0].minValue);
            //    action.changeApplySum("");
            //}
            var buyConfirmDate = jsonResult.buyConfirmDate;
            $("#predictConfirmDate").html(this.mm_dd(buyConfirmDate)+"("+this.dayOfWeek(buyConfirmDate)+")");
            jsonResult.bankCards=$.hsf.hsTools.remove(jsonResult.bankCards,"capitalmode","E");//屏蔽支付宝信息
            if (jsonResult.bankCards.length > 0) {
                $(".selectedBankName").html(jsonResult.bankCards[0].bankname);
                $(".selectedBankcardNo").html(this.mask(jsonResult.bankCards[0].bankacco));
                $(".selectedBankcardNo2").html("(尾号"+this.mask2(jsonResult.bankCards[0].bankacco)+")");
                $(".selectedBankcardIcon").addClass("bank-logo bank-"+jsonResult.bankCards[0].alias);
                $(".selectedBankcardMiniIcon").addClass("bank-"+jsonResult.bankCards[0].alias);

                var firstBankcard = jsonResult.bankCards[0];
                if(firstBankcard.capitalmode=="M" || firstBankcard.capitalmode=="3"||firstBankcard.capitalmode=="4"||firstBankcard.capitalmode=="N") {
                    $("#limitTip")[0].style.visibility = "visible";
                    $("#noticeIcon")[0].style.visibility = "visible";
                    $("#banklimit").html("此卡支付限额：单笔" + (firstBankcard.onceMaxValue || "--") + "万，日累计" + (firstBankcard.dayMaxValue || "--") + "万");
                }else{
                    $("#limitTip")[0].style.visibility = "hidden";
                    $("#noticeIcon")[0].style.visibility="hidden";
                    $("#banklimit").html("");
                }
            } else {
                $.UIConfirm({"html":"您还没有可以交易的银行卡，是否添加?", "submitText":"确定","cancelText":"取消"}, function(result) {
                    if (result == "yes") {
                        $.hsf.hsOpen("account-addAcco-tl-validate.html");
                    } else {
                        $.hsf.hsBack();
                    }
                });
            }
        },
        dayOfWeek : function(yyyymmdd) {
            if (typeof yyyymmdd == "string") {
                var dayInt = (new Date(yyyymmdd.substr(0,4), parseInt(yyyymmdd.substr(4,2))-1, yyyymmdd.substr(6,2))).getDay();
                var day = action.constant.day[dayInt];
                return day;
            } else {
                return yyyymmdd;
            }
        },
        mm_dd : function(yyyymmdd) {
            if (typeof yyyymmdd == "string") {
                return yyyymmdd.substr(4,2)+"-"+yyyymmdd.substr(6,2);
            } else {
                return yyyymmdd;
            }
        },
        mask : function(str) {
            if (str.length > 8) {
                return str.substr(0,4)+"********"+str.substr(str.length-4,4);
            } else {
                return str
            }
        },
        packLimitPage : function() {
            var config = require("static/trade-money-in-limit");
            var html = "<dd> <div m-role=\"cell\" m-mode=\"x\" m-layout=\"fit\" m-padding=\"1 1 1 1\"> <div m-role=\"cell\" m-padding=\"0 1 0 0\"><div class=\"bank-logo \"></div></div> <div m-role=\"cell\" m-mode=\"y\" m-margin=\"0 0 0 1\" m-valign=\"middle\" m-padding=\"0 0 0 1\"> <div class=\"m-font-big bankname\" m-margin=\"0 0 1 0\" ></div> <div class=\"m-font-normal m-color-9\">单笔限额<span class=\"onceMaxValue\"></span>元，单日<span class=\"dayMaxValue\" ></span>元。</div> </div> </div> </dd>";
            var $limitList = $("#limitList");
            var $dl = $limitList.find("dl");
            for (var index in config.details) {
                var $html = $(html);
                $html.find(".bankname").html(config.details[index].bank_ch);
                $html.find(".onceMaxValue").html(config.details[index].onceMaxValue);
                $html.find(".dayMaxValue").html(config.details[index].dayMaxValue);
                $html.find(".bank-logo").addClass("bank-"+config.details[index].bank_en);
                $dl.append($html);
            }
            $limitList.UITableView("refresh");
        },
        packBanklist : function(jsonResult) {
            var html = "<dd m-type=\"mark\" m-marked=\"\" m-id=\"\"  m-selectionstyle=\"\"> <a href=\"buy.html\"  class=\"back\" m-role=\"cell\" m-mode=\"x\" m-layout=\"fit\" m-padding=\"1 1 1 1\"> <div m-role=\"cell\" m-padding=\"0 1 0 0\" class=\"capitalicon\"><div class=\"bank-logo \"></div></div> <div m-role=\"cell\" m-mode=\"y\" m-margin=\"0 0 0 1\" m-valign=\"middle\" m-padding=\"1 0 1 1\"> <div class=\"m-font-big bankname2\" m-margin=\"0 0 1 0\"></div> <div class=\"m-font-small m-color-6 cardno\"></div> </div> </a> </dd>";
            var $bankcardList = $("#bankcardList");
            var $dl = $bankcardList.find("dl");
            for (var index in jsonResult.bankCards) {
                var $html = $(html);
                $html.find(".bankname2").html(jsonResult.bankCards[index].bankname);
                $html.find(".cardno").html("(尾号:"+action.mask2(jsonResult.bankCards[index].bankacco)+")");
                $html.attr("m-id", index);
                $html.find(".bank-logo").addClass("bank-"+jsonResult.bankCards[index].alias);
                $dl.append($html);
            }
            $bankcardList.find("dd").first().attr("m-marked", "yes");
            $bankcardList.UITableView("refresh");
            $.hsf.stopLoading();
        },
        mask2 : function(str) {
            return str.length > 4 ? str.substr(str.length-4,4) : str;
        },
        getApplySum : function() {
            return $.hsf.hsTools.recoveryMoney($("#applysum").UITextField("value"));
        },
        changeMoney:function(sign, changevalue){
            var tmpValue=0;
            var inputValue=  action.getApplySum() ==""? 0 :  action.getApplySum();
            if(sign){
                tmpValue=parseInt(inputValue,10)+parseInt(changevalue,10);
            }else{
                tmpValue=parseInt(inputValue,10)-parseInt(changevalue,10);
                tmpValue = tmpValue < 0 ? 0 : tmpValue;
            }
            action.changeApplySum(tmpValue);
        },
        changeApplySum : function(tmpValue) {
            var applysum;
            if (tmpValue) {
                applysum = tmpValue;
            } else {
                applysum = action.getApplySum();
            }
            $(".buy-big-write").html($.hsf.hsTools.chineseNum(applysum));
            $("#applysum").UITextField("value", $.hsf.hsTools.formatMoney(applysum));
        },
        event : function() {

            $(".up-btn-search").bind("tap",function () {
                $.hsf.hsOpen("bankcard.html");
                return false
            })
            $(".money-btn").bind("tap", function() {
                var _self = $(this);
                var changemoney = _self.find(".change-value").html();
                if (_self.hasClass("money-reduce")) {
                    action.changeMoney(false , changemoney)
                } else {
                    action.changeMoney(true , changemoney)
                }
                return false;
            })
            //充值金额联动显示
            $("#applysum input").bind("input", function() {
                var _self=$(this),
                    val=_self.val(),
                    exp=/^[-]?([1-9]{1}[0-9]{0,}(\.[0-9]{0,2})?|0(\.[0-9]{0,2})?|\.[0-9]{1,2})$/g;
                val = val.toString().replace(/,/g, '');
                if(!exp.test(val)) {
                    var value = val.replace(/[^0-9,\.]/g,"");
                    if(value.substr(value.indexOf(".")).length>3)
                    {
                        _self.blur();
                        $.UIPopup("请输入数字(例:0.00),最高保留两位小数");
                    }
                    var str=$.hsf.hsTools.formatMoney(value,true);
                    $("#applysum").UITextField("value",str );
                    return false;
                }
                return false;
                /*applysum = action.getApplySum();
                $(".confirmsum").html(applysum+"元");
                return false;*/
            });
            $("#limitBtn, #bankcardSelect,#nextTo2Btn").bind("tap", function() {
                if ("nextTo2Btn" == $(this).attr("id")) {
                    if (!action.formValidate()) {
                        return ;
                    }
                    $(".confirmsum").html($("#applysum").UITextField("value")+"元");
                    //action.sandclock.start();
                }
                $("#first").removeClass('view-active');
                $("#"+$(this).attr("for")).addClass('view-active');
                $('body').removeClass('m-bg-ee').addClass('m-bg-white');
                return false;
            });
            $("#limitBackBtn, #bankcardBackBtn, #secondBackBtn").on("tap", function() {
                $(this).parents(".view").removeClass('view-active');
                $("#first").addClass('view-active');
                $('body').removeClass('m-bg-white').addClass('m-bg-ee');
                return false;
            });
            $("#selectBank").bind("change",function(){
               var v= $("#selectBank option:selected").val()
                if(v.indexOf(".html")!=-1){
                    action.constant.addBank = true;
                    $.hsf.hsOpen(v);
                    return false;
                }

                var activeBankIndex = $("#selectBank").UISelectField("value");
                action.constant.activeBankIndex = activeBankIndex;
                $(".selectedBankName").html(action.constant.result.bankCards[activeBankIndex].bankname);
                //$(".selectedBankcardNo").html(action.mask(action.constant.result.bankCards[activeBankIndex].bankacco));
                $(".selectedBankcardNo2").html("(尾号"+action.mask2(action.constant.result.bankCards[activeBankIndex].bankacco)+")");
                $(".selectedBankcardMiniIcon").removeAttr("class").addClass("selectedBankcardMiniIcon bank-logo-tiny bank-"+action.constant.result.bankCards[activeBankIndex].alias);
                //$(".selectedBankcardIcon").removeAttr("class").addClass("selectedBankcardIcon bank-logo bank-"+action.constant.result.bankCards[result].alias);
                //$("#minlimit").html(action.constant.result.bankCards[result].onceMaxValue/10000);
                //$("#daylimit").html(action.constant.result.bankCards[result].dayMaxValue/10000);
                //if(action.constant.result.bankCards[result].onceMaxValue==null){
                //    $("#cardlimit").hide();
                //}
                if(action.constant.result.bankCards[activeBankIndex].capitalmode == "M" || action.constant.result.bankCards[activeBankIndex].capitalmode == "3"||action.constant.result.bankCards[activeBankIndex].capitalmode=="4"||action.constant.result.bankCards[activeBankIndex].capitalmode=="M"){
                    var oncemax = action.constant.result.bankCards[activeBankIndex].onceMaxValue || "--";
                    var daymax = action.constant.result.bankCards[activeBankIndex].dayMaxValue || "--";
                    $("#noticeIcon")[0].style.visibility="visible";
                    $("#banklimit").html("此卡支付限额：单笔"+oncemax+"万，日累计"+daymax+"万");
                    $("#limitTip")[0].style.visibility="visible";
                }else{
                    $("#limitTip")[0].style.visibility = "hidden";
                    $("#noticeIcon")[0].style.visibility="hidden";
                    $("#banklimit").html("");
                }

            });

            //$("#bankcardList").UITableView("mark", function(result) {
            //    $(".selectedBankName").html($.hsf.hsTools.banknameDeal(action.constant.result.bankCards[result].bankname));
            //    $(".selectedBankcardNo").html(action.mask(action.constant.result.bankCards[result].bankacco));
            //    $(".selectedBankcardNo2").html("(尾号"+action.mask2(action.constant.result.bankCards[result].bankacco)+")");
            //    $(".selectedBankcardMiniIcon").removeAttr("class").addClass("selectedBankcardMiniIcon bank-logo-tiny bank-"+action.constant.result.bankCards[result].alias);
            //    $(".selectedBankcardIcon").removeAttr("class").addClass("selectedBankcardIcon bank-logo bank-"+action.constant.result.bankCards[result].alias);
            //    $("#minlimit").html(action.constant.result.bankCards[result].onceMaxValue/10000);
            //    $("#daylimit").html(action.constant.result.bankCards[result].dayMaxValue/10000);
            //    if(action.constant.result.bankCards[result].onceMaxValue==null){
            //        $("#cardlimit").hide();
            //    }
            //    console.log(this);
            //    $(this).parent().parent().parent().parent().hide();
            //    $("#first").show();
            //});
            $("#purchaseBtn").bind("tap", function() {
                //if(!action.sandclock.readyStart()) return false;
                if (action.formValidate2()) {
                    var selectCard = action.constant.result.bankCards[action.constant.activeBankIndex];
                    var tradeData ="businflag=022";
                    var tradepassword = $("#tradepassword").UITextField("value");
                    tradeData+="&fundcode="+action.constant.result.fundcode
                        +"&sharetype=A"
                        +"&tradeacco="+selectCard.tradeacco
                        +"&detailcapitalmode="+selectCard.paymode
                        +"&applysum="+action.getApplySum()
                        +"&capsource=0"
                        +"&busintype=01"
                        +"&tradepassword=" + tradepassword;
                    $.hsf.startLoading("正在提交申请...");
                    $.hsf.ajax.app("moneyfund/charge/charge", tradeData, "purchaseCallback", function(jsonResult) {
                        $.hsf.stopLoading();
                        if (jsonResult.successful) {
                            if(jsonResult.cperrorcode2 && jsonResult.cperrorcode2 == "0862"){
                                $.UIAlert(jsonResult.errormsg,function () {
                                    //跳转到签约页面,
                                    var pay=selectCard;
                                    var mobile = "";
                                    //这个页面这些信息,就先不传了,下个页面请求getUserInfo再获取。
                                    var bankParam = "bankname="+pay.bankname+"&bankacco="+pay.bankacco+"&capitalmode="+pay.capitalmode+"&bankserial="+pay.bankserial+"&tradeacco="+pay.tradeacco+"&custname="+"&idtype="+"&idno="+"&mobile="+mobile;
                                    $.hsf.hsOpen("account-bankcard-tl-renewsign.html?"+bankParam);
                                    return false;
                                });
                                return false;
                            }
                            platformApi.buySuccess();
                            if (jsonResult.payState == "0" || jsonResult.payState == "3") {//扣款中.
                                $("#stateText").html("扣款中");
                                $("#state0").show();
                                if(jsonResult.incomeCaculateDay && jsonResult.incomeQueryDay){
                                    $("#date1").html(action.mm_dd(jsonResult.incomeCaculateDay) +" "+ action.dayOfWeek(jsonResult.incomeCaculateDay));
                                    $("#date2").html(action.mm_dd(jsonResult.incomeQueryDay) +" "+ action.dayOfWeek(jsonResult.incomeQueryDay));
                                }
                                $("#dateFlow").show();
                            } else if (jsonResult.payState == "1") {//失败
                                $("#stateText").html(jsonResult.errormsg);
                                $("#state1").show();
                            } else if (jsonResult.payState == "2") {//成功
                                $("#stateText").html("扣款成功");
                                $("#state2").show();
                                if(jsonResult.incomeCaculateDay && jsonResult.incomeQueryDay){
                                    $("#date1").html(action.mm_dd(jsonResult.incomeCaculateDay) +" "+ action.dayOfWeek(jsonResult.incomeCaculateDay));
                                    $("#date2").html(action.mm_dd(jsonResult.incomeQueryDay) +" "+ action.dayOfWeek(jsonResult.incomeQueryDay));
                                }
                                $("#dateFlow").show();
                            }
                            $("#second").removeClass('view-active');
                            $("#third").addClass('view-active');
                            $.hsf.stopLoading();
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            });
        },
        formValidate : function(){
            if (action.constant.addBank) {
                var v= $("#selectBank option:selected").val()
                if(v.indexOf(".html")!=-1){
                    $.UIConfirm({"html":"请选择银行卡，或者添加其他银行卡", "submitText":"添加"}, function(result) {
                        if (result == "yes") {
                            window.location.href = "account-addAcco-tl-validate.html";
                        }else {
                            window.location.reload();
                        }
                    });
                    return false;
                } else {
                    var activeBankIndex = $("#selectBank").UISelectField("value");
                    action.constant.activeBankIndex = activeBankIndex;
                }
            }
            var applysum = action.getApplySum();
            var checkContract = $("#checkContract").UICheckBox("value");
            var normalMoney =/^[0-9]+(.[0-9]{1,2})?$/;
            if(""==applysum){
                $.UIPopup("请输入充值金额!");
                return false;
            }
            if(0>=applysum){
                $.UIPopup("充值金额必须大于0!");
                return false;
            }
            if(!normalMoney.test(applysum)){
                $.UIPopup("输入金额小数点后最多两位");
                return false;
            }
            if(/[M3]/.test(action.constant.result.bankCards[action.constant.activeBankIndex].capticalmode)) {
                var oncelimit = action.constant.result.bankCards[action.constant.activeBankIndex].onceMaxValue;
                if (oncelimit && parseFloat(oncelimit) * 10000 < applysum) {
                    $.UIPopup("单笔交易不能高于" + oncelimit + "万元");
                    return false;
                }
            }
            if (checkContract != "yes") {
            	$.UIPopup("同意服务协议后才可充值");
            	return false;
            }
            return true;
        },
        formValidate2 : function(){
            var tradepassword = $("#tradepassword").UITextField("value");
            if ("" == tradepassword) {
                $.UIPopup("交易密码不能为空");
                return false;
            }
            return true;
        },
        sandclock :  {//倒计时方法
            run : function() {
                if (action.constant.counter ==0) {
                    $("#purchaseBtn").attr("m-state","");
                    $("#purchaseBtn").html("确认");
                    action.constant.counter=-1;
                } else {
                    $("#purchaseBtn").html((action.constant.counter)+" 秒");
                    // setTimeout("action.sandclock.run()", 1000);
                    action.constant.counter--;
                    action.constant.timer = setTimeout(action.sandclock.run.bind(action), 1000);
                }
            },
            start : function() {
                //清除上次
                if( action.constant.timer) clearTimeout( action.constant.timer);
                action.constant.counter = action.constant.repeatSeconds;
                $("#purchaseBtn").attr("m-state","disabled");
                $("#purchaseBtn").html((action.constant.counter--)+" 秒");
                setTimeout(action.sandclock.run.bind(action), 1000);
            },
            readyStart : function() {
                if (action.constant.counter == -1) {
                    return true;
                } else {
                    return false;
                }
            }
        },
        renderAWarning:function(jsonResult){
            //如果不是专业投资者,显示tip
            if(jsonResult.pubprofessionflag != "1"){
                if(!jsonResult.warningAContent)
                    jsonResult.warningAContent = jsonResult.riskmatchResult.riskmsg;
                $("#tip").html(jsonResult.warningAContent).UITip("show");
                this.makeTrace("A");//留痕
            }
        },
        makeTrace:function(type,requestno,pflag){
            var jsonResult = action.constant.result;
            requestno = requestno || "";
            var typestr = "warning"+type+"No";
            if(pflag == "1" && jsonResult.pubprofessionflag!="1") return ;//下单成功后C类仅专业投资者才留痕
            this.requestTrace({
                warningno:jsonResult[typestr],
                businflag:"022",
                fundcode:jsonResult.fundcode,
                content:jsonResult["warning"+type+"Content"],
                //fundrisklevel:jsonResult.productRiskLevel,
                //custrisktype:jsonResult.accoRiskability,
                requestno:requestno
            });
        },
        requestTrace:function(data){
            var param = $.map(data,function(value,key){
                return key+"="+value
            }).join("&");
            $.hsf.ajax.app("account/risk/trace",param,"traceCallback",function(jsonResult) {
                if (jsonResult.successful) {
                }
            });
        }
    };
    return action;
});
