define([$.hsf.platform()], function(platform) {
	var moduleapi = platform.api["login-view"];
	moduleapi["loginSuccess"] = function() {
		$.UIAlert("绑定成功", function() {
			$.hsf.hsOpen("index.html");
		});
	};
	$.platform = $.extend(moduleapi, platform.baseapi);
	var action = {
		init : function() {
			$.platform.initPage && $.platform.initPage();
			this.events();
		},
		events : function() {
			// 默认身份证
			$("#accountNo").UITextField("idtype", "0")
			$("#accountType").UISelectField("change", function () {
				// 证件类型改变时重新设置证件号码长度
				var accountType = $("#accountType").UISelectField("value")
				$("#accountNo").UITextField("idtype", accountType)
			})


			$("#loginButton").bind("tap", function() {
				action.checkLoginCode();
				return false;
			});

			$("#accountNo").on("click",function(){
				var certificate = "";
				var accountNoHidden = $("#accountNoHidden").val();
				var accountInput = $("#accountNo").UITextField("value");
				if (accountNoHidden && accountNoHidden != "" && accountInput.indexOf("****") > 0) {
					certificate = accountNoHidden;
				} else {
					certificate = accountInput;
				};
				$("#accountNo").UITextField("value",certificate);
				return false;
			});
		},
		getAccountNo : function() {
			var accountNoHidden = $("#accountNoHidden").val();
			var accountInput = $("#accountNo").UITextField("value");
			if (accountNoHidden && accountNoHidden != "" && accountInput.indexOf("****") > 0) {
				return accountNoHidden;
			} else {
				return accountInput;
			}
		},
		checkLoginCode : function() {
			var account = action.getAccountNo().trim(),
				pw = $("#pw").UITextField("value").trim(),
				accountType = $("#accountType").UISelectField("value"),
				verifycode = $("#verifycode").UITextField("value"),
				data = "certificatetype=" + accountType + "&lognumber=" + account + "&password=" + pw+"&channel="+$.platform.channel
					+"&bindwx=1"
					+"&authcode="+verifycode;
			var checkContract = $("#checkContract").UICheckBox("value");
			if (account.length === 0) {
				$.UIPopup("请输入号码");
				return false;
			}
			if (pw.length === 0) {
				$.UIPopup("请输入密码");
				return false;
			}
			if (pw.length > $.hsf.pwLength) {
				$.UIPopup("密码长度不能超过" + $.hsf.pwLength + "位");
				return false;
			}
			$("input").blur();
			$.hsf.startLoading();
			$.hsf.ajax.app($.platform.loginUrl, data, "checkLoginCode", this.loginCallback);
		},
		loginCallback : function(jsonResult) {
			$.hsf.stopLoading();
			if (jsonResult && jsonResult.successful) {
				var accountType= $("#accountType").UISelectField("value").trim()||"";
				$.platform.putCache("accountTypeStr", accountType);
				$.hsf.hsTools.hgxTradeRestrictQuery(accountType, platformApi, function () {
						$.platform.loginSuccess();
						$.platform.putCache("loginInfo",{custRole:jsonResult.custRole});
				});

			} else {
				if (jsonResult.needauthcode == "1") {
					$("#verifycodeDD").show();
					$("#verifycodeImg").attr("src", $.hsf.appBaseUrl+"authcode.jpg");
				}
				$.hsf.callFailProcess(jsonResult);
			}
			return false;
		}
	}
	return action;
});
