define([$.hsf.platform()], function (platform) {
	var platformApi = $.hsf.getModuleAPI(platform, 'login-view');
	var action = {
		historyBack: true,
		disableHistoryBack: function () {
			action.historyBack = false;
		},
		constant:{
			accountType:''
		},
		init: function () {
			platformApi.getCache('deviceId', function (deviceId) {
				action.deviceId = deviceId || ''
			});
			action.historyBack = true;
			$('[m-role=\'UITextField\']').UITextField();
			$('[m-role=\'UISelectField\']').UISelectField();
			$('[m-role=\'UICheckBox\']').UICheckBox();
			platformApi.initPage && platformApi.initPage(action);
			this.events();
		},
		events: function () {

			// 默认身份证
			$("#accountNo").UITextField("idtype", "0")
			$("#accountType select").change(function () {
				var accountType = $("#accountType").UISelectField("value")
				$("#accountNo").UITextField("idtype", accountType)
			})
			// $("#accountType").UISelectField("change", function () {
			// 	// 证件类型改变时重新设置证件号码长度
			//
			// })


			$('#loginButton').bind('tap', function () {
				action.checkLoginCode();
			});
			$('#backBtn').bind('tap', function () {
				try {
					action.historyBack && platformApi.hsBack();
					action.popDown();
					platformApi.resetBackbutton && platformApi.resetBackbutton()
				} catch (e) {
					console.log(e);
				}
			});

			$('#loginForm_certificatetype').bind('change', function (e) {
				e.preventDefault();
				var val = $(this).find('option:selected').text();
				if(val.indexOf('身份证')!==-1){
					val='身份证号';
				}
				$('#accountNo').attr('m-placeholder', val);
				$('#accountNo input').attr('placeholder', val);
				return false;
			});

			$('#accountNo').on('click', function () {
				var accountInput = $('#accountNo').UITextField('value');
				if (accountInput.indexOf('****') > 0) {
					$('#accountNo').UITextField('value', '');
					$('#accountNoHidden').remove();
				}
				return false;
			})
		},
		getAccountNo: function () {
			var accountNoHidden = $('#accountNoHidden').val();
			var accountInput = $('#accountNo').UITextField('value');
			if (accountInput.indexOf('****') > 0 && accountNoHidden) {
				return accountNoHidden;
			} else {
				return accountInput;
			}
		},
		checkLoginCode: function () {
			var account = action.getAccountNo().trim();
			var pw = $('#pw').UITextField('value').trim();
			var accountType = $('#accountType').UISelectField('value');
			var verifycode = $('#verifycode').UITextField('value');

			action.constant.accountType=accountType;
			var data = 'certificatetype=' + accountType
				+ '&lognumber=' + account
				+ '&password=' + pw
				+ '&channel=' + platformApi.channel
				+ '&bindwx=1'
				+ '&authcode=' + verifycode
				+ '&deviceId=' + action.deviceId;
			if (accountType == 'M') {
				data += '&custname=';
			}
			var checkContract = $('#checkContract').UICheckBox('value');
			if (account.length === 0) {
				$.UIPopup('请输入号码');
				return false;
			}
			if (!/^.{6,16}$/.test(pw)) {
				$.UIPopup('请输入正确的密码');
				return false;
			}
			if (typeof checkContract == 'string' && checkContract != 'yes') {
				$.UIPopup('请仔细阅读《用户注册协议》且同意接受条款。');
				return false;
			}
			$('input').blur();
			$.hsf.startLoading();
			$.hsf.ajax.app(platformApi.loginUrl, data, 'checkLoginCode', this.loginCallback);
		},
		saveCertificate:function(){
			var certificate = "";
			var accountNoHidden = $("#accountNoHidden").val();
			var accountInput = $("#accountNo").UITextField("value");
			if(accountNoHidden && accountNoHidden != "" && accountInput.indexOf("****") > 0) {
				certificate = accountNoHidden;
			} else {
				certificate = accountInput;
			}
			var certificateType = action.constant.accountType;//action.selectBox.getVal();
			var accountTypeName = action.constant.accountTypeName;
			var rememberFlag = $("#checkPw").attr("m-checked");
			if(rememberFlag == "yes") {
				try {
					$.platform.putCache("login", {
						"certificate": certificate,
						"certificateType": certificateType,
						"rememberFlag": rememberFlag,
						"accountTypeName":accountTypeName
					},"local");
				} catch(e) {
					console.log(e);
				}
			} else {
				$.platform.removeCache("login","local"); //argv是一个json格式的字符串
			}
		},
		loginCallback: function (jsonResult) {
			if (jsonResult && jsonResult.successful) {
				// 合规性校验
				var accountType=$("#accountType").UISelectField("value").trim()||"";
				$.platform.putCache("accountTypeStr", accountType);

				var updateCurrentLoginKey = function () {
					if (jsonResult.mobile && jsonResult.mobile != "") {
						$.platform.updateCurrentLoginKey(jsonResult.mobile);
					} else {
						$.platform.updateCurrentLoginKey(action.getAccountNo());
					}
				};
				if(platformApi.channel == 'android'){
					updateCurrentLoginKey();
				}
				if(platformApi.channel == 'android' ){
					$.platform.putCache("token", jsonResult.data)
				}
				action.saveCertificate();
				if (platformApi.channel == 'iphone') {
					if ($.hsf.handPassword.enable) {
						platformApi.resetToken(jsonResult.data);
					}
				}
				$.hsf.hsTools.hgxTradeRestrictQuery(accountType, platformApi, function(){
					$.platform.putCache('loginInfo', { custRole: jsonResult.custRole });
					action.triggerSucc(jsonResult);
				});
			} else {
				if (jsonResult.needauthcode == '1') {
					$('#verifycodeDD').show();
					$('#verifycodeImg').attr('src', $.hsf.appBaseUrl + 'authcode.jpg');
				}
				if ('ETS-5BP0037' == jsonResult.code || jsonResult.code == 'ETS-5BP0035') {
					$.UIPopup('请用身份证登录或更换手机号码!');
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			}
			$.hsf.stopLoading();
			return false;
		},
		triggerSucc: function (jsonResult) {
			platformApi.loginSuccess && platformApi.loginSuccess();
			if (jsonResult && jsonResult.custRole != 'A') {
				// $.hsf.hsTools.checkInvestmentSuitabilityAll(function(){
				// 	$.hsf.Event.trigger("login", function() {
				// 		setTimeout(function() {action.popDown()}, 500);
				//
				// 	});
				// });
				$.hsf.hsTools.checkInvestmentSuitabilityAll(function () {
					setTimeout(function succ () {
						$.hsf.Event.trigger('login', function () {
							action.popDown();
						})
					}, 500);
				},true);
			} else {
				setTimeout(function succ () {
					$.hsf.Event.trigger('login', function () {
						action.popDown();
					});
				}, 500);
			}
		},
		popDown: function () {
			$('#login').bind('webkitAnimationEnd', function () {
				$('#login').remove();
			}).removeClass('pop-up').addClass('pop-down');
		}
	};
	return action;
});

