
define([$.hsf.platform()],function(platform){
   var platformApi = $.hsf.getModuleAPI(platform, "modify-mobile");
   window.action = {
       constant:{
           counter:0,
           repeatSeconds: 60,
       },

       logininfo:null,

       init : function(){
           action.events();
           action.getUserInfo();
       },
       events : function () {
           $("#submit").bind("tap", function() {
               $("#code input").blur();
               $("#newPhone input").blur();
               $("#password input").blur();
                    action.validateForm();

               return false;
           });

           $("#smscodebtn").bind("tap", function() {
               //action.sandclock.start();
               action.sendAuthcode();
               return false;
           });
       },
       getUserInfo: function() {
           $.hsf.startLoading();
           $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack", function(jsonResult) {
               if (jsonResult.successful) {
                   $.hsf.stopLoading();
                   $("#idnostr").html(jsonResult.result.idnostr);
                   if(jsonResult.result.handset&&jsonResult.result.handset.length>0){

                       $("#oldPhone").html($.hsf.hsTools.removePrefix(jsonResult.result.handset));
                    //action.oldphone=jsonResult.result.handset;
                       action.logininfo = jsonResult.result;
                   }else{
                       $.UIAlert("请先绑定手机号",function () {
                           $.hsf.hsBack();
                       });
                   }
                   //$("#email").html(jsonResult.result.email);
                   //$("#riskablityType").html(jsonResult.riskabilitystr);
               } else {
                   $.hsf.callFailProcess(jsonResult);
               }
           });
       },
       validateForm:function(){
           var handsetReg = /^[0-9]{11}$/;
           var numReg = /^\d+$/;

           var code=$("#code").UITextField("value").trim();
           var newPhone=$("#newPhone").UITextField("value").trim();
           var password=$("#password").UITextField("value").trim();
           if ("" == code) {
               $.UIAlert("请输入验证码！");
               return false;
           }else if ("" == newPhone) {
               $.UIAlert("请输入新手机号！");
               return false;
           }else if(!handsetReg.test(newPhone)){
               $.UIAlert("新手机号码应为11位数字！");
               return false;
           }else   if(action.logininfo.handset==newPhone){
               $.UIAlert("新手机号码不能与原手机号相同");
               return false;
           }else   if ("" == password) {
               $.UIAlert("请输入交易密码！");
               return false;
           }else {
               $.hsf.ajax.app("atomicquery/account/mobileusedinfo", "mobileno="+newPhone, "mobileusedinfo", function (jsonResult) {
                   if (jsonResult.successful) {
                       var dcisexist = jsonResult.mobileUsedInfoQueryResult.dcisexist;
                       var dsisexist = jsonResult.mobileUsedInfoQueryResult.dsisexist;
                       if (dsisexist == 1) {
                           $.UIPopup("该手机号已经被使用，请使用其他手机号");
                           return;
                       }else{
                           var data="mobile="+$.hsf.hsTools.removePrefix(action.logininfo.handset)
                               + "&custno="+action.logininfo.custno
                               + "&authcode="+code
                               + "&identitytype="+action.logininfo.idtype
                               + "&identityno="+action.logininfo.idno
                               + "&handset="+encodeURIComponent(['86', newPhone].join('|'))
                               + "&way=1&sendintent=toOld"+"&tradepassword="+password;
                           action.doSubmit(data);
                       }
                   }else{
                       $.hsf.callFailProcess(jsonResult);
                   }
               });
           }
       },
       //获取验证码
       sendAuthcode:function(){
           if (this.sandclock.readyStart()) {

               var data = "mobile="+$.hsf.hsTools.removePrefix(action.logininfo.handset)
                   +"&way=1&sendintent=toOld"
                   + "&custno="+action.logininfo.custno
                   + "&identitytype="+action.logininfo.idtype
                   + "&identityno="+action.logininfo.idno;
               $.hsf.startLoading();//$.hsf.startLoading("正在获取...");
               $.hsf.ajax.app("account/mobile/sendCode", data, "sendbankauthcodeCallback", function(jsonResult) {
                   $.hsf.stopLoading();
                   if(jsonResult.successful){
                       $("#authcode_show").remove();
                       $("#authcode").show();
                       action.constant.accoreqserial=jsonResult.accoreqserial;
                       action.constant.otherserial="";
                       $.UIAlert("手机验证码已发送！请注意查收短信！");
                       action.sandclock.start();
                   } else {
                       $.hsf.callFailProcess(jsonResult);
                   }
               });
           }
       },
       sandclock :  {
           run : function() {
               if (action.constant.counter == 0) {
                   $("#smscodebtn").attr("m-state","");
                   $("#smscodebtn").html("获取");
               } else {
                   $("#smscodebtn").html((action.constant.counter--)+"秒");
                   setTimeout("action.sandclock.run()", 1000);
               }
           },
           start : function() {
               action.constant.counter = action.constant.repeatSeconds;
               $("#smscodebtn").attr("m-state","disabled");
               $("#smscodebtn").html((action.constant.counter--)+"秒");
               setTimeout("action.sandclock.run()", 1000);
           },
           readyStart : function() {
               if (action.constant.counter == 0) {
                   return true;
               } else {
                   false;
               }
           }
       },
    	doSubmit: function(data) {
            $.hsf.startLoading();
            $.hsf.ajax.app("account/mobile/updateMobilePhone", data, "updateMobileCallBack", function(jsonResult) {
                if (jsonResult.successful) {
                    $.hsf.stopLoading();
                    $.UIAlert("修改成功",function () {
                        $.hsf.hsOpen("account-info.html");
                        // $.hsf.hsBack();
                    })
                } else {
                    $.hsf.callFailProcess(jsonResult);
                    $("#code").UITextField("value","");
                    $("#newPhone").UITextField("value","");
                    $("#password").UITextField("value","");
                }
            });
        }
   } ;
    return action;
});
