﻿define(function (require) {
    var action = {
        constant: {
            result: null,//表单结果
            tradeFareList: [],//费率信息集合
            cost: null,//申购费用
            save: null,//节省费用
            fundcode: $.hsf.hsTools.getParam("fundcode"),
            fundlist: null,
            buybusin: $.hsf.hsTools.getParam("buybusin"),
            sharetype: $.hsf.hsTools.getParam("sharetype"),
            counter: 0,//计时器
            chooseCard: null,
            repeatSeconds: 10//倒计时时间
        },
        init: function () {
            var that = this;
            $.hsf.hsTools.investmentSuitability(function () {
                that.packForm();
                that.event();
            });
        },
        packForm: function () {
            $.hsf.startLoading();
            Array.prototype.remove = function (dx) {
                if (isNaN(dx) || dx > this.length) {
                    return false;
                }
                for (var i = 0, n = 0; i < this.length; i++) {
                    if (this[i] != this[dx]) {
                        this[n++] = this[i];
                    }
                }
                this.length -= 1;
            };
            action.packNamelist(action.constant.fundcode,action.selectedFundcode);	/*名称*/
        },
        // 跳转或下拉
          selectedFundcode: function () {
            if (!!action.constant.fundcode) { // 购买两个入口，非选择购买的时候地址栏显示基金名称，选择购买的时候，地址栏不显示基金名称。
              action.initAgreeFunc();
            } else {
              // 如果不是列表页进入的购买，有下拉选择
              var v = $("#selectFundname").UISelectField("value");
              var fundcode = action.constant.fundlist[v] && action.constant.fundlist[v].fundcode;
              action.initAgreeFunc(fundcode);
            }
          },
        // 初始化信息披露
        initAgreeFunc: function (fundcode) { // 默认的基金
            $.platform.getCache("agreeUserInfo", function (r) {
                if (!!r) {
                    $.hsf.hsTools.initAgree(fundcode||action.constant.fundcode, r.result.idno, r.result.idtype,$("#main"),$("#fundRatePage"));
                } else {
                    $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack", function (jsonResult) {
                        if (jsonResult && jsonResult.successful) {
                            $.platform.putCache("agreeUserInfo", jsonResult);
                            $.hsf.hsTools.initAgree(fundcode||action.constant.fundcode, jsonResult.result.idno, jsonResult.result.idtype,$("#main"),$("#fundRatePage"));
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            })
        },
        /**初始化**/
        packFirstPage: function (jsonResult) {
            //$(".fundname").html(jsonResult.fundname);
            //080011，qdii基金，新发基金
            if (jsonResult.fundcode != $.hsf.XJB.xjbcode && jsonResult.businflag != "020" && jsonResult.fundtype != "6") {
                $(".jspdiscountTip").css("visibility", "visible");
                if (jsonResult.moneyfundextra) {
                    var discount = JSON.parse(jsonResult.moneyfundextra).jspDiscount;
                    $("#jspDiscount").html(discount || "");
                }
            } else {
                $(".jspdiscountTip").css("visibility", "hidden");
            }
            $(".fundcode").html(jsonResult.fundcode);
            action.renderAWarning(jsonResult);
            //$(".notice-box").html(jsonResult.warningCContent);
            $("#showfundname").html(jsonResult.fundname);
            $("#showfundnamerisklevel").html(jsonResult.riskmatchResult.fundriskStr);
            $("#custrisklevel").html(jsonResult.riskmatchResult.riskbilityStr);
            action.renderLowRiskLimit(jsonResult);
            if (jsonResult.buyLimitResult.limits.length > 0) {
                $("#tipMinValue").css("visibility", "visible");
                $("#minValue").html("购买金额不低于" + jsonResult.buyLimitResult.limits[0].minValue + "元");
                $("#applysum").UITextField("value", jsonResult.buyLimitResult.limits[0].minValue);
                //action.changeApplySum(jsonResult.buyLimitResult.limits[0].minValue.toString());
            }
            var buyConfirmDate = jsonResult.buyConfirmDate;
            $("#buyDate").html(action.getDate());
            $("#predictConfirmDate").html($.hsf.hsTools.mm_dd(buyConfirmDate) + "(" + $.hsf.hsTools.dayOfWeek(buyConfirmDate) + ")");
            if (jsonResult.bankCards.length == 0 && jsonResult.moneyPayCards.length == 0) {
                $.UIAlert("您还没有可以交易的银行卡", function (result) {
                    $.hsf.hsBack();
                });
            } else {
                var bankSelect = document.getElementById("bankSelect");
                bankSelect.options.length = 1;
                bankSelect[0] = new Option("请选择", 0);
                var tag = {
                    "M": "通联_",
                    "3": "银联_",
                    "4": "快捷_",
                    "N": "中行_",
                };

                // 工行快捷显示
                // 已签约的工行网银卡需要显示为
                jsonResult.moneyPayCards = $.hsf.hsTools.toQuickStr(jsonResult.moneyPayCards, "工行网银", "工商银行")
                if (jsonResult.moneyPayCards.length > 0) {
                    $("#noticeIcon")[0].style.visibility = "hidden";
                    for (var i = 0; i < jsonResult.moneyPayCards.length; i++) {
                        var moneybank = jsonResult.moneyPayCards[i];
                        if (moneybank.capitalmode == "M" || moneybank.capitalmode == "3" || moneybank.capitalmode == "4" || moneybank.capitalmode == "N") {
                            moneybank.bankInfo = tag[moneybank.capitalmode] + moneybank.bankInfo.replace(/.+?[-_]/g, "");
                        }
                        var bankname = moneybank.bankInfo;
                        bankSelect[i + 1] = new Option("盛钱宝 " + bankname, i + 1);
                        bankSelect[i + 1].setAttribute("m-logo", "bank-" + moneybank.alias);
                    }
                } else {
                    $("#feeCompute").show();
                }
                // 已签约的工行网银卡需要显示为
                jsonResult.bankCards = $.hsf.hsTools.toQuickStr(jsonResult.bankCards, "工行网银", "工商银行")
                if (jsonResult.bankCards.length > 0) {
                    listLength = bankSelect.options.length;
                    for (var j = 0; j < jsonResult.bankCards.length; j++) {
                        var bank = jsonResult.bankCards[j];
                        if (bank.capitalmode == "M" || bank.capitalmode == "3" || bank.capitalmode == "4" || bank.capitalmode == "N") {
                            bank.bankInfo = tag[bank.capitalmode] + bank.bankInfo.replace(/.+?[-_]/g, "");
                        }
                        bankSelect[listLength + j] = new Option(bank.bankInfo, listLength + j);
                        bankSelect[listLength + j].setAttribute("m-logo", "bank-" + bank.alias);
                    }
                }
                var lenOfAllBankLength = bankSelect.options.length;
                bankSelect[lenOfAllBankLength] = new Option("添加新的银行卡", "account-addAcco-tl-validate.html");
            }
            action.constant.sharetype = jsonResult.sharetypes[0].key || "A";
            if (jsonResult.businflag == "020") {
                $("#businflagText").html("认购金额");
            } else {
                $("#businflagText").html("申购金额");
            }
            if (jsonResult.buyConfirmDate)
                $("#buyConfirmDate").html(jsonResult.buyConfirmDate.substr(0, 4) + "." + jsonResult.buyConfirmDate.substr(4, 2) + "." + jsonResult.buyConfirmDate.substr(6, 2));
        },
        packNamelist: function (fundcode,cb) {
            var that = this;
            if (typeof (fundcode) == "string") {
              that.initSingleBuyForm();
              cb();
            } else {
                $.hsf.ajax.app("product/product/queryFundListSequence", "sequenceField=fundNameFirstPinyinName&sequenceWay=asc", "productListback", function (jsonResult) {
                    if (jsonResult.successful) {
                        if (jsonResult.resultList && jsonResult.resultList.length > 0) {
                            for (var i = 0; i < jsonResult.resultList.length; i++) {
                                if (jsonResult.resultList[i].buybusin == "nobuy") {
                                    jsonResult.resultList.remove(i);
                                }
                            }
                        }
                        action.constant.fundlist = jsonResult.resultList;
                        var fundnameSelect = document.getElementById("fundnameSelect");
                        fundnameSelect.options.length = 0;
                        $(".fundname").html(action.constant.fundlist[0].fundname);
                        for (var i = 0; i < action.constant.fundlist.length; i++) {
                            fundnameSelect[i] = new Option(action.constant.fundlist[i].fundname, i);
                        }
                      that.selectFund();
                      cb();
                        action.constant.fundcode = action.constant.fundlist[0].fundcode;
                        action.constant.buybusin = action.constant.fundlist[0].buybusin;
                        action.constant.sharetype = action.constant.fundlist[0].sharetype;
                        that.initMultiBuyForm();
                        $("#fundNameDouble").show();
                        $("#fundNameSingle").hide();
                    } else {
                        $.hsf.callFailProcess(jsonResult);
                    }
                });
            }
        },
        initSingleBuyForm: function () {
            var data = "fundcode=" + action.constant.fundcode;
            if (action.constant.buybusin)
                data += "&businflag=" + action.constant.buybusin;
            $.hsf.ajax.app("trade/buy/buyForm", data + "&warningchannel=" + $.platform.warningchannel + "&antiMoneyBusinestype="+action.constant.buybusin, "chargeFormCode", function (jsonResult) {
                if (jsonResult.successful) {
                    $.hsf.stopLoading();
                    $.hsf.hsTools.checkHgxForTrade(jsonResult, function () {//检查合规性
                        action.constant.result = jsonResult;
                        $("#fundNameSingle").html(jsonResult.fundname).show();
                        $(".fundname").html(jsonResult.fundname);
                        $("#fundNameDouble").hide();
                        action.packFirstPage(jsonResult);
                        //action.packBanklist(jsonResult);
                        //action.getDiscount();
                    });
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        initMultiBuyForm: function () {
            var data = "fundcode=" + action.constant.fundcode;
            if (action.constant.buybusin)
                data += "&businflag=" + action.constant.buybusin;
            $.hsf.ajax.app("trade/buy/buyForm", data + "&warningchannel=" + $.platform.warningchannel + "&antiMoneyBusinestype="+action.constant.buybusin, "chargeFormCode", function (jsonResult) {
                if (jsonResult.successful) {
                    $.hsf.stopLoading();
                    $.hsf.hsTools.checkHgxForTrade(jsonResult, function () {//检查合规性
                        action.constant.result = jsonResult;
                        action.packFirstPage(jsonResult);
                        //action.packBanklist(jsonResult);
                        //action.getDiscount();
                    });
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        getDiscount: function (callback, error) {
            var tradeacco = action.constant.selectedTradeAcco.tradeacco,
                requestbala = action.getApplySum();
            if (!tradeacco) {
                $.UIAlert("请选择银行卡");
                error && error();
                return;
            }
            if (requestbala == "") {
                $.UIAlert("请输入金额");
                error && error();
                return;
            }
            var data = "fundcode=" + action.constant.fundcode +
                "&businflag=" + action.constant.buybusin +
                "&sharetype=" + action.constant.sharetype +
                "&requestbala=" + requestbala + "&tradeacco=" + tradeacco;
            $.hsf.startLoading("正在估算费用...");
            $.hsf.ajax.app("trade/buy/tradeFare", data, "chargeFormCode", function (jsonResult) {
                if (jsonResult.successful) {
                    $.hsf.stopLoading();
                    if (jsonResult.tradeFareBean && jsonResult.tradeFareList.length > 0) {
                        var fare = jsonResult.tradeFareList[0];
                        callback && callback(fare);
                    } else {
                        $.UIAlert("估算费用失败!", function () {
                            callback && callback(fare);
                        });
                    }
                    //action.constant.result = jsonResult;
                    //action.constant.tradeFareList=jsonResult.tradeFareList;
                    //action.packBanklist(action.constant.result);
                } else {
                    error && error();
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        packBanklist: function (jsonResult) {
            if (jsonResult.moneyPayCards.length > 0) {
                var moneycard = jsonResult.moneyPayCards[0];
                $(".selectedBankcardMiniIcon").addClass("bank-" + moneycard.alias);
                $("#selectBankLogo").removeClass().addClass('bank-logo-min bank-' + moneycard.alias);
                if(moneycard.bankname.indexOf("工行网银")!=-1){
                    $(".selectedBankName").html(moneycard.bankname.replace("工行网银","快捷_工商银行"));
                }else{
                    $(".selectedBankName").html(moneycard.bankname);
                }
                $(".selectedBankcardNo2").html("(尾号" + $.hsf.hsTools.maskCardHead(moneycard.bankacco) + ")");
                $("#noticeIcon")[0].style.visibility = "visible";
                $("#limitTip")[0].style.visibility = "visible";
                $("#banklimit").html("盛钱宝 " + moneycard.bankname + "可用金额" + (moneycard.usableShare || "--") + "元");
                action.constant.selectedTradeAcco = moneycard;
                action.constant.selectedTradeAcco.capsource = "1";   //现金宝
                $("#feeCompute").hide();
            } else {
                if (jsonResult.bankCards.length > 0) {
                    var bcard = jsonResult.bankCards[0];
                    if(bcard.bankname.indexOf("工行网银")!=-1){
                        $(".selectedBankName").html(bcard.bankname.replace("工行网银","快捷_工商银行"))
                    }else{
                        $(".selectedBankName").html(bcard.bankname)
                    }
                    $("#selectBankLogo").removeClass().addClass('bank-logo-min bank-' + bcard.alias);
                    $(".selectedBankcardNo2").html("(尾号" + $.hsf.hsTools.maskCardHead(bcard.bankacco) + ")");
                    $(".selectedBankcardMiniIcon").addClass("bank-" + bcard.alias);
                    var bankname = bcard.bankname;//.split("_");
                    if (bcard.capitalmode == "M" || bcard.capitalmode == "3" || bcard.capitalmode == "4" || bcard.capitalmode == "N") {
                        $("#limitTip")[0].style.visibility = "visible";
                        $("#noticeIcon")[0].style.visibility = "visible";
                        $("#banklimit").html(bankname + "卡支付限额：单笔" + (bcard.onceMaxValue || "--") + "万，日累计" + (bcard.dayMaxValue || "--") + "万");
                    } else {
                        $("#limitTip")[0].style.visibility = "hidden";
                        $("#noticeIcon")[0].style.visibility = "hidden";
                        $("#banklimit").html("");
                    }
                    action.constant.selectedTradeAcco = bcard;
                    action.constant.selectedTradeAcco.capsource = "0"; //银行卡
                }
            }
        },
        getApplySum: function () {
            return $.hsf.hsTools.recoveryMoney($("#applysum").UITextField("value"));
        },
        changeMoney: function (sign, changevalue) {
            var tmpValue = 0;
            var inputValue = action.getApplySum() == "" ? 0 : action.getApplySum();
            if (sign) {
                tmpValue = parseInt(inputValue, 10) + parseInt(changevalue, 10);
            } else {
                tmpValue = parseInt(inputValue, 10) - parseInt(changevalue, 10);
                tmpValue = tmpValue < 0 ? 0 : tmpValue;
            }
            action.changeApplySum(tmpValue);
        },
        changeApplySum: function (tmpValue) {
            var applysum;
            if (tmpValue) {
                applysum = tmpValue;
            } else {
                applysum = action.getApplySum();
            }
            if (/\.\d{2}\d+/.test(applysum))
                applysum = applysum.substr(0, applysum.lastIndexOf(".") + 3);
            $(".buy-big-write").html($.hsf.hsTools.chineseNum(applysum));
            $("#applysum").UITextField("value", applysum);
            $(".confirmsum").html(applysum + "元");
        },
        tobuy: function () {
            var $this = $("#nextTo2Btn");
            action.renderBWarning(function () {
                var shareTypeText = action.constant.result.sharetypes[0].value;
                $(".fee1").html(shareTypeText);
                $(".confirmsum").html($("#applysum").UITextField("value") + "元");
                $("#first").removeClass('view-active');
                $("#" + $this.attr("for")).addClass('view-active');
                if (action.constant.result.fundtype != "2") {//货币基金不显示10s倒计时
                    action.sandclock.start();
                }
            });
        },
        event: function () {
            $(".up-btn-search").bind("tap", function () {
                $.hsf.hsOpen("bankcard.html");
                return false;
            });
            $("#trade-agreement-agree").bind("tap", function () {
                var checkContract2 = $("#checkContract2");
                if (!checkContract2.is(':checked')) {
                    $.UIPopup("请确认已阅读《风险不匹配警示函》和《投资者确认书》!");
                } else {
                    $("#tradeAgreementPage").hide();
                    $("#first").addClass('view-active');
                    action.tobuy();
                    return false;
                }
                return false;
            });
            $("#trade-agreement-cancel").bind("tap", function () {
                $("#tradeAgreementPage").hide();
                $("#first").addClass('view-active');
                return false;
            });
            action.feeCompute();
            action.selectBank();
            $(".money-btn").bind("tap", function () {
                var _self = $(this);
                var changemoney = _self.find(".change-value").html();
                if (_self.hasClass("money-reduce")) {
                    action.changeMoney(false, changemoney)
                } else {
                    action.changeMoney(true, changemoney)
                }
                return false;
            });
            $("#applysum input").bind("input", function () {
                //action.changeApplySum();
                //return false;
                var _self = $(this),
                    val = _self.val(),
                    exp = /^[-]?([1-9]{1}[0-9]{0,}(\.[0-9]{0,2})?|0(\.[0-9]{0,2})?|\.[0-9]{1,2})$/g;
                val = val.toString().replace(/,/g, '');
                if (!exp.test(val)) {
                    var value = val.replace(/[^0-9,\.]/g, "");
                    if (value.substr(value.indexOf(".")).length > 3) {
                        _self.blur();
                        $.UIPopup("请输入数字(例:0.00),最高保留两位小数");
                    }
                    var str = $.hsf.hsTools.formatMoney(value, true);
                    $("#applysum").UITextField("value", str);
                    return false;
                }
                if ($("#feeCkb").attr("m-checked") == "yes") {
                    $("#feeCkb").attr("m-checked", "no");
                    $("#feeComputeTxt").html("点击按钮即可计算");
                }
                return false;
            });
            $("#limitBtn, #bankcardSelect,#nextTo2Btn").bind("tap", function () {
                if ("nextTo2Btn" == $(this).attr("id")) {
                    var above_risk = $(this).hasClass("above_risk");
                    if (above_risk) {
                        $.UIAlert("您的风险等级过低，不允许购买该产品！");
                        return false;
                    }
                    if (!$.hsf.hsTools.checkRead()) {
                        return false;
                    }
                    if (!action.formValidate()) {
                        return false;
                    } else {
                        var $this = $(this);
                        action.renderCWarning(function () {
                            action.tobuy();
                        });
                        return false;
                    }
                }
                $("#first").removeClass('view-active');
                $("#" + $(this).attr("for")).addClass('view-active');
                return false;
            });
            $("#limitBackBtn, #bankcardBackBtn, #secondBackBtn,#tradeAgreementBackBtn").on("tap", function () {
                $(this).parents(".view").removeClass('view-active');
                $("#tradepassword").UITextField("value", "");
                $("#first").addClass('view-active');
                return false;
            });
            $("#purchaseBtn").bind("tap", function () {
                $("#tradepassword input").blur();
                if (action.constant.result.fundtype != "2") {
                    if (!(action.sandclock.readyStart())) return false;
                }
                if (action.formValidate2()) {
                    var selectCard = action.constant.selectedTradeAcco;
                    var tradepassword = $("#tradepassword").UITextField("value");
                    var tradeData;
                    if (action.constant.selectedTradeAcco.capsource == "1") {//现金宝
                        tradeData = "businflag=" + action.constant.result.businflag + "&fundcode=" + action.constant.result.fundcode + "&sharetype=" + action.constant.result.sharetypes[0].key + "&tradeacco=" + selectCard.tradeacco + "&applysum=" + action.getApplySum() + "&capsource=" + selectCard.capsource + "&tradepassword=" + tradepassword;
                    } else {
                        tradeData = "businflag=" + action.constant.result.businflag + "&fundcode=" + action.constant.result.fundcode + "&sharetype=" + action.constant.result.sharetypes[0].key + "&tradeacco=" + selectCard.tradeacco + "&detailcapitalmode=" + selectCard.paymode + "&applysum=" + action.getApplySum() + "&capsource=" + selectCard.capsource + "&tradepassword=" + tradepassword;
                    }
                    // 信披入参
                    if ($.hsf.infoDisclosure.enable) {
                        tradeData += "&channelno=3"
                            + "&antiMoneyBusinestype="+action.constant.buybusin
                    }
                    $.hsf.startLoading("正在提交申请...");
                    $.hsf.ajax.app("trade/buy/buy", tradeData, "purchaseCallback", function (jsonResult) {
                        $.hsf.stopLoading();
                        if (jsonResult.successful) {
                            if (jsonResult.cperrorcode2 && jsonResult.cperrorcode2 == "0862") {
                                $.UIAlert(jsonResult.errormsg, function () {
                                    //跳转到签约页面,
                                    var pay = action.constant.chooseCard;
                                    var mobile = "";
                                    //这个页面这些信息,就先不传了,下个页面请求getUserInfo再获取。
                                    var bankParam = "bankname=" + pay.bankname + "&bankacco=" + pay.bankacco + "&capitalmode=" + pay.capitalmode + "&bankserial=" + pay.bankserial + "&tradeacco=" + pay.tradeacco + "&custname=" + "&idtype=" + "&idno=" + "&mobile=" + mobile;
                                    $.hsf.hsOpen("account-bankcard-tl-renewsign.html?" + bankParam);
                                    return false;
                                });
                                return false;
                            }
                            if (action.constant.result.riskmatchResult.riskflag == "1" || action.constant.result.riskmatchResult.riskflag == "2" || action.constant.result.riskmatchResult.riskflag == "3") {
                                jsonResult.purchaseResult && action.makeTrace("C", jsonResult.purchaseResult.applyserial || "");
                            }
                            $(".fundname").html(action.constant.result.fundname);
                            if (jsonResult.payState == "0" || jsonResult.payState == "3") { //扣款中.
                                $("#stateText").html("扣款中");
                                $("#state0").show();
                                $("#date1").html($.hsf.hsTools.mm_dd(jsonResult.commitTime) + " " + $.hsf.hsTools.dayOfWeek(jsonResult.commitTime));
                                $("#date2").html($.hsf.hsTools.mm_dd(jsonResult.shareConfirmDay) + " " + $.hsf.hsTools.dayOfWeek(jsonResult.shareConfirmDay));
                                $("#dateFlow").show();
                            } else if (jsonResult.payState == "1") { //失败
                                $("#stateText").html(jsonResult.errormsg);
                                $("#state1").show();
                            } else if (jsonResult.payState == "2") { //成功
                                $("#stateText").html("扣款成功");
                                $("#state2").show();
                                $("#date1").html($.hsf.hsTools.mm_dd(jsonResult.commitTime) + " " + $.hsf.hsTools.dayOfWeek(jsonResult.commitTime));
                                $("#date2").html($.hsf.hsTools.mm_dd(jsonResult.shareConfirmDay) + " " + $.hsf.hsTools.dayOfWeek(jsonResult.shareConfirmDay));
                                $("#dateFlow").show();
                            }
                            $("#second").removeClass('view-active');
                            $("#third").addClass('view-active');
                            $.hsf.stopLoading();
                        } else if (jsonResult.code == "ETS-5BP0010" || jsonResult.code == "1035" || jsonResult.code == "1036") {
                            $.UIAlert("请先做风险评估", function () {
                              $.hsf.hsOpen("risk-test.html");
                            });
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            });
        },
        formValidate: function () {
            var val = $("#bankSelect").val();
            if (val == 0) {
                $.UIPopup("请选择支付方式!");
                return false;
            }
            var applysum = action.getApplySum();
            if ("" == applysum) {
                $.UIPopup("请输入购买金额!");
                return false;
            }
            if (0 >= applysum) {
                $.UIPopup("购买金额必须大于0!");
                return false;
            }
            if (action.constant.result.buyLimitResult && action.constant.result.buyLimitResult.limits.length > 0 && action.constant.result.buyLimitResult.limits[0].minValue) {
                if (applysum < action.constant.result.buyLimitResult.limits[0].minValue) {
                    $.UIPopup("购买金额不得少于" + action.constant.result.buyLimitResult.limits[0].minValue + "元");
                    return false;
                }
            }
            if (action.constant.selectedTradeAcco.capsource == "1") {
                if (parseFloat(applysum) > parseFloat(action.constant.selectedTradeAcco.usableShare)) {
                    $.UIPopup("您的购买的金额超过了现金宝可用余额" + action.constant.selectedTradeAcco.usableShare + "元。");
                    return false;
                }
            }
            if (action.constant.selectedTradeAcco && /[M3]/.test(action.constant.selectedTradeAcco.capitalmode)) {
                var oncelimit = action.constant.selectedTradeAcco.onceMaxValue;
                if (oncelimit && parseFloat(oncelimit) * 10000 < applysum) {
                    $.UIPopup("单笔交易不能高于" + oncelimit + "万元");
                    return false;
                }
            }
            return true;
        },
        formValidate2: function () {
            var tradepassword = $("#tradepassword").UITextField("value").trim();
            if ("" == tradepassword) {
                $.UIPopup("请输入交易密码");
                return false;
            }
            return true;
        },
        //费用计算
        feeCompute: function () {
            $("#feeCkb").on('tap', function (e) {
                var checkbox = $(this),
                    txt = $("#feeComputeTxt");
                if (checkbox.attr('m-checked') != "yes") {
                    txt.text('点击按钮即可计算');
                } else {
                    calcFee();
                }
                function calcFee() {
                    action.getDiscount(function (result) {
                        checkbox.attr("m-checked", "yes");
                        var save = result.discountrate == 0 ? 0 : (result.fare / result.discountrate - result.fare);
                        txt.text("(本次预计费用" + result.fare + "元,已节省" + parseFloat(save).toFixed(2) + "元)");
                    }, function () {
                        checkbox.attr("m-checked", "no");
                    });
                }
                return false;
            });
        },
        selectBank: function () {
            $("#selectBank").UISelectField("change", function (value) {
                if (value.indexOf(".html") != -1) {
                    $.hsf.hsOpen(value);
                    return false;
                } else if (value == 0) {
                    $(".selectedBankName").html("");
                    $(".selectedBankcardNo2").html("");
                    $("#noticeIcon")[0].style.visibility = "hidden";
                    $("#limitTip")[0].style.visibility = "hidden";
                    $("#banklimit").html("");
                    action.constant.selectedTradeAcco = "";
                    action.constant.selectedTradeAcco.capsource = "";
                    $("#feeCompute").hide();
                    $("#selectBankLogo").removeClass();
                    $(".selectedBankcardMiniIcon").removeAttr("class");
                    return;
                }
                var self = $(this),
                    bankLogo = "";
                self.find("option").each(function () {
                    var _self = $(this);
                    if (_self.val() == value) {
                        bankLogo = _self.attr("m-logo");
                    }
                });
                if (self.val() - 1 < action.constant.result.moneyPayCards.length) {
                    var moneycard = action.constant.result.moneyPayCards[self.val() - 1];
                    action.constant.chooseCard = moneycard;
                    if(moneycard.bankname.indexOf("工行网银")!=-1){
                        $(".selectedBankName").html(moneycard.bankname.replace("工行网银","快捷_工商银行"));
                    }else{
                        $(".selectedBankName").html(moneycard.bankname);
                    }

                    $(".selectedBankcardNo2").html("[" + action.getLastFourNumber(moneycard.bankacco) + "]");
                    $("#noticeIcon")[0].style.visibility = "visible";
                    $("#limitTip")[0].style.visibility = "visible";
                    $("#banklimit").html("盛钱宝 " + moneycard.bankname + "可用金额" + (moneycard.usableShare || "--") + "元");
                    action.constant.selectedTradeAcco = moneycard;
                    action.constant.selectedTradeAcco.capsource = "1"; //现金宝
                    $("#feeCompute").hide();
                } else {
                    if (action.constant.result.bankCards.length > 0) {
                        var current = action.constant.result.bankCards[self.val() - 1 - action.constant.result.moneyPayCards.length];
                        action.constant.chooseCard = current;
                        if(current.bankname.indexOf("工行网银")!=-1){
                            $(".selectedBankName").html(current.bankname.replace("工行网银","快捷_工商银行"));
                        }else{
                            $(".selectedBankName").html(current.bankname);
                        }

                        $(".selectedBankcardNo2").html("[" + action.getLastFourNumber(current.bankacco) + "]");
                        var bankname = current.bankname;//.split("_");
                        if (current.capitalmode == "M" || current.capitalmode == "3" || current.capitalmode == "4" || current.capitalmode == "N") {
                            var oncemax = current.onceMaxValue || "--";
                            var daymax = current.dayMaxValue || "--";
                            $("#noticeIcon")[0].style.visibility = "visible";
                            $("#banklimit").html(bankname + "卡支付限额：单笔" + oncemax + "万，日累计" + daymax + "万");
                            $("#limitTip")[0].style.visibility = "visible";
                        } else {
                            $("#limitTip")[0].style.visibility = "hidden";
                            $("#noticeIcon")[0].style.visibility = "hidden";
                            $("#banklimit").html("");
                        }
                        action.constant.selectedTradeAcco = current;
                        action.constant.selectedTradeAcco.capsource = "0"; //银行卡
                        $("#feeCompute").show();
                        if ($("#feeCkb").attr("m-checked") == "yes") {
                            $("#feeCkb").attr("m-checked", "no");
                            $("#feeComputeTxt").html("点击按钮即可计算");
                        }
                    }
                }
                $("#selectBankLogo").removeClass().addClass('bank-logo-min ' + bankLogo);
                $(".selectedBankcardMiniIcon").removeAttr("class").addClass("selectedBankcardMiniIcon bank-logo-tiny " + bankLogo);
            });
        },
        selectFund: function () {
            var that = this;
            $("#selectFundname").UISelectField("change", function (value) {
                if (value <= action.constant.fundlist.length) {
                    action.constant.fundcode = action.constant.fundlist[value].fundcode;
                    action.constant.buybusin = action.constant.fundlist[value].buybusin;
                    action.constant.sharetype = action.constant.fundlist[value].sharetype;
                    action.initAgreeFunc(); // 信披
                    $(".fundname").html(action.constant.fundlist[value].fundname);
                    $.hsf.startLoading();
                    that.initMultiBuyForm();
                    if ($("#feeCkb").attr("m-checked") == "yes") {
                        $("#feeCkb").attr("m-checked", "no");
                        $("#feeComputeTxt").html("点击按钮即可计算");
                    }
                }
            });
        },
        /*取银行卡后四位*/
        getLastFourNumber: function (str) {
            return str.length > 4 ? str.substr(str.length - 4, 4) : str;
        },
        //获取当前日期
        getDate: function () {
            var myDate = new Date();
            var y = myDate.getFullYear();
            var m = myDate.getMonth() + 1;
            var d = myDate.getDate();
            if (m <= 9) {
                m = "0" + m;
            }
            if (d <= 9) {
                d = "0" + d;
            }
            return y + "." + m + "." + d;
        },
        sandclock: {//倒计时方法
            run: function () {
                if (action.constant.counter == 0) {
                    $("#purchaseBtn").attr("m-state", "").html("确认");
                    action.constant.counter = 0;
                } else {
                    $("#purchaseBtn").html((action.constant.counter--) + " 秒");
                    action.constant.timer = setTimeout(action.sandclock.run.bind(action), 1000);
                }
            },
            start: function () {
                //清除上次
                if (action.constant.timer) clearTimeout(action.constant.timer);
                action.constant.counter = action.constant.repeatSeconds;
                $("#purchaseBtn").attr("m-state", "disabled").html((action.constant.counter--) + " 秒");
                setTimeout(action.sandclock.run.bind(action), 1000);
            },
            readyStart: function () {
                if (action.constant.counter == 0) {
                    return true;
                } else {
                    return false;
                }
            }
        },
        renderAWarning: function (jsonResult) {
            //如果不是专业投资者,显示tip
            if (jsonResult.pubprofessionflag != "1") {
                $("#tip").html(jsonResult.warningAContent).UITip("show");
                this.makeTrace("A");//留痕
            }
        },
        renderBWarning: function (callback) {
            var that = this;
            var jsonResult = action.constant.result;
            if (jsonResult.pubprofessionflag != "1" && jsonResult.productRiskLevel == $.hsf.theHighestRiskLevel) {
                $.UIConfirm({
                    "html": jsonResult.warningBContent,
                    "submitText": "取消",
                    "cancelText": "确认"
                }, function (result) {
                    if (result == "no") {
                        that.makeTrace("B");
                        callback && callback.call(that);
                    }
                });
            } else {
                callback && callback.call(that);
            }
        },
        renderCWarning: function (callback) {
            var that = this;
            var jsonResult = action.constant.result;
            if (jsonResult.riskmatchResult.riskflag == "1" || jsonResult.riskmatchResult.riskflag == "2" || jsonResult.riskmatchResult.riskflag == "3") {//不匹配
                $("#tradeAgreementPage").show();
                $("#first").removeClass('view-active');
            } else {
                callback && callback.call(that);
            }
        },
        makeTrace: function (type, requestno, pflag) {
            var jsonResult = action.constant.result;
            requestno = requestno || "";
            var typestr = "warning" + type + "No";
            this.requestTrace({
                warningno: jsonResult[typestr],
                businflag: jsonResult.businflag,
                fundcode: jsonResult.fundcode,
                content: jsonResult["warning" + type + "Content"],
                fundrisklevel: jsonResult.productRiskLevel,
                custrisktype: jsonResult.accoRiskability,
                requestno: requestno
            });
        },
        requestTrace: function (data) {
            var param = $.map(data, function (value, key) {
                return key + "=" + value
            }).join("&");
            $.hsf.ajax.app("account/risk/trace", param, "traceCallback", function (jsonResult) {
                if (jsonResult.successful) {
                }
            });
        },
        renderLowRiskLimit: function (jsonResult) {
            var minriskflag = jsonResult.minriskflag;
            var fundrisklevel = jsonResult.productRiskLevel;
            var riskflag = jsonResult.riskmatchResult.riskflag;
            if (minriskflag && fundrisklevel) {
                if ((minriskflag == "1" && fundrisklevel > $.hsf.theLowestRiskLevel) || riskflag == "3") {
                    $("#nextTo2Btn").addClass("above_risk").attr("m-state", "disabled");
                } else {
                    $("#nextTo2Btn").attr("m-state", "").removeClass("above_risk")
                }
            } else {
                $("#nextTo2Btn").attr("m-state", "").removeClass("above_risk")
            }
        }
    };
    return action;
});
