﻿define(function(require) {
	var action = {
		constant : {
			fundcode : $.hsf.hsTools.getParam("fundcode"),
			fundname : $.hsf.hsTools.getParam("fundname"),
			requestTradeacco : $.hsf.hsTools.getParam("tradeacco"),
			sharetype : $.hsf.hsTools.getParam("sharetype"),
			day : ["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],
			result : null,
			targettradeacco:null,
			saleway: null
		},
		init : function() {
			var that = this;
			$.hsf.hsTools.investmentSuitability(function () {
				that.packForm();
				that.event();
			});
		},
		packForm : function() {
			$.hsf.startLoading();
			var reqParam = "fundcode="+action.constant.fundcode;
			reqParam += action.constant.requestTradeacco ? ("&tradeacco="+action.constant.requestTradeacco+"&sharetype=A") : "";
			reqParam+="&antiMoneyBusinestype=024";
			$.hsf.ajax.app("trade/sale/saleForm", reqParam, "chargeFormCode", function(jsonResult) {
				if (jsonResult.successful) {
					$.hsf.hsTools.checkHgxForTrade(jsonResult,function(){//检查合规性
						action.constant.result = jsonResult;
//						$("#fundName").html(jsonResult.fundname);
//						$(".fundcode").html(action.constant.fundcode);
//					$.doTemplate("minlimit", jsonResult.minShare);
						action.packFirstPage(jsonResult);
						action.packBanklist(jsonResult);
						//是货币基金时候显示可选赎回方式
						if(jsonResult.fundtype=="2"){
							$("#payType").html("<option value='2'>请选择</option><option value='0'>银行卡</option>");
							$("#sharetype").show();
							action.enchashType();
						}else{
							$("#payType").html("<option value='2'>请选择</option><option value='1'>盛钱宝</option><option value='0'>银行卡</option>");
						}
						$.hsf.stopLoading();
					});
				} else {
					$.hsf.callFailProcess(jsonResult);
				}
			});
		},
		packFirstPage : function(jsonResult) {
			action.constant.saleway="";
			$(".fundname").html(jsonResult.fundname);
			$(".fundcode").html(action.constant.fundcode);
			$("#saleDate").html(action.getDate());
			if(jsonResult.fundtype=="2"){//货币基金快速赎回确认时间为当天
				$("#saleConfirmDate").html(action.getDate());
			}else{
				if(jsonResult.expactedPayBackDate){
					$("#saleConfirmDate").html(jsonResult.expactedPayBackDate.substr(0,4)+"."+jsonResult.expactedPayBackDate.substr(4,2)+"."+jsonResult.expactedPayBackDate.substr(6,2));
				}
			}
			if (jsonResult.shareList.length > 0) {
				$(".selectedBankName").html(jsonResult.shareList[0].bankname);
				$(".selectedBankcardNo").html(this.mask(jsonResult.shareList[0].bankacco));
				$(".selectedBankcardNo2").html("(尾号"+action.mask2(jsonResult.shareList[0].bankacco)+")");
				$.doTemplate("tip", {usableremainshare: parseFloat(jsonResult.shareList[0].usableremainshare), minShare : parseFloat(action.constant.result.minShare)}, "refresh");
				$(".selectedBankcardIcon").addClass("bank-logo bank-"+jsonResult.shareList[0].alias);
				$("#selectBankLogo").removeClass().addClass('bank-logo-min bank-' + jsonResult.shareList[0].alias);
				$(".selectedBankcardMiniIcon").addClass("bank-logo-tiny bank-"+jsonResult.shareList[0].alias);
				$("#usableshareDiv").html(jsonResult.shareList[0].usableremainshare);

				if(jsonResult.shareList[0].sharetype&&jsonResult.shareList[0].sharetype=="前收费"){
					action.constant.sharetype="A";
				}else if(jsonResult.shareList[0].sharetype&&jsonResult.shareList[0].sharetype=="后收费"){
					action.constant.sharetype="B";
				}else{
					action.constant.sharetype=jsonResult.shareList[0].sharetype;
				}
				action.constant.requestTradeacco=jsonResult.shareList[0].tradeacco;
				//if(action.constant.fundcode == $.hsf.XJB.xjbcode){
				//$("#selectSaleway").UISelectField("value",0);
				//$("#selectSaleway option[value='1']").remove();
				//action.constant.saleway="0";
				//}
			}else{
				$.UIAlert("代销或第三方资产请到原购买渠道办理，谢谢！");
			}
		},
		mask : function(str) {
			if (str.length > 8) {
				return str.substr(0,4)+"********"+str.substr(str.length-4,4);
			} else {
				return str
			}
		},
		packBanklist : function(jsonResult) {
			var bankSelect = document.getElementById("bankSelect");
			bankSelect.options.length = 0;
			if (jsonResult.shareList.length > 0) {
				for (var i = 0; i < jsonResult.shareList.length; i++) {
					var bankname = jsonResult.shareList[i].bankname;//.split("_");
					/*if (bankname[1] == null) {
					 bankname[1] = jsonResult.shareList[i].bankname;
					 }*/
					bankSelect[i] = new Option(bankname+"[尾号"+action.mask2(jsonResult.shareList[i].bankacco)+"]", i);
					bankSelect[i].setAttribute("m-logo", "bank-" + jsonResult.shareList[i].alias);
				}
			}
			var lenOfAllBankLength = bankSelect.options.length
			bankSelect[lenOfAllBankLength]=new Option("添加新的银行卡","account-addAcco-tl-validate.html")
		},
		mask2 : function(str) {
			return str.length > 4 ? str.substr(str.length-4,4) : str;
		},
		getApplySum : function() {
			return $.hsf.hsTools.recoveryMoney($("#applysum").UITextField("value"));
		},
		// 取现方式
		enchashType: function () {
			var selectBox = $(".select-box"),
				selectValBox = $(".select-val-box"),
				selectOptBoxClo = $(".select-option-box").clone();
			selectBox.on('tap', function () {
				$("input").blur();
				$("body").append('<div class="mask-box"></div>');
				var maskBox = $(".mask-box");
				maskBox.append(selectOptBoxClo);
				maskBox.on('tap', function (e) {
					if ($(e.target).hasClass('select-option-box') || $(e.target).parents(".select-option-box").length > 0) {
						return false;
					}
					closeSelectBox();
				});
				$(".mask-box .select-option").on('tap', function () {
					var _self = $(this);
					$("#typeSelect .select-option:eq(" + _self.index() + ")").addClass('active').siblings().removeClass('active');
					_self.addClass('active').siblings().removeClass('active');
					if( _self.index()==0){
						$("#saleConfirmDate").html(action.getDate());
					}else if( _self.index()==1){
						$("#saleConfirmDate").html(action.constant.result.expactedPayBackDate.substr(0,4)+"."+action.constant.result.expactedPayBackDate.substr(4,2)+"."+action.constant.result.expactedPayBackDate.substr(6,2));
					}
					closeSelectBox();
					return false;
				});
				function closeSelectBox() {
					maskBox.addClass('close');
					setTimeout(function () {
						maskBox.remove();
					}, 300);
				}
				return false;
			});
		},

		event : function() {
			action.selectBank();
			action.selectSaleway();
			$("#limitBtn, #bankcardSelect,#nextTo2Btn").bind("tap", function() {
				if ("nextTo2Btn" == $(this).attr("id")) {
					if (!action.formValidate()) {
						return ;
					}
					$(".confirmsum").html(action.getApplySum()+"份");
				}
				$("#first").removeClass('view-active');
				$("#"+$(this).attr("for")).addClass('view-active');
				return false;
			});
			$(".up-btn-search").bind("tap",function () {
				$.hsf.hsOpen("bankcard.html");
				return false
			});
			$("#limitBackBtn, #bankcardBackBtn, #secondBackBtn").on("tap", function() {
				$(this).parents(".view").removeClass('view-active');
				$("#tradepassword").UITextField("value", "");
				$("#first").addClass('view-active');
				return false;
			});
//			$("#bankcardList").UITableView("mark", function(result) {
//				$(".selectedBankName").html(action.constant.result.shareList[result].bankname);
//				$(".selectedBankcardNo").html(action.mask(action.constant.result.shareList[result].bankacco));
//				$(".selectedBankcardNo2").html("(尾号"+action.mask2(action.constant.result.shareList[result].bankacco)+")");
//				$.doTemplate("tip", {usableremainshare:action.constant.result.shareList[result].usableremainshare, minShare : action.constant.result.minShare}, "refresh");
//				$(".selectedBankcardMiniIcon").removeAttr("class").addClass("selectedBankcardMiniIcon bank-logo-tiny bank-"+action.constant.result.shareList[result].alias);
//				$(".selectedBankcardIcon").removeAttr("class").addClass("selectedBankcardIcon bank-logo bank-"+action.constant.result.shareList[result].alias);
//				$(this).parents(".view").removeClass('view-active');
//				$("#first").addClass('view-active');
//			});
			$("#saleBtn").bind("tap", function() {
				$("#tradepassword input").blur();
				if (action.formValidate2()) {
					var tradepassword = $("#tradepassword").UITextField("value");
					var tradeData="";
					if($("#payType").children().length==2){//先判断如果只能选银行卡的时候
						action.constant.saleway = $("#typeSelect>.select-option-box>.select-option.active [m-name='saleway-type']").attr("value");
						tradeData="targettradeacco=" + action.constant.requestTradeacco+"&";
					}tradeData  =tradeData + "saleway="+action.constant.saleway
					+ "&sharetype=" + action.constant.sharetype
					+ "&fundcode="+action.constant.result.fundcode
					+"&tradeacco="+ action.constant.requestTradeacco
					+"&applysum="+  action.getApplySum()
					+"&tradepassword=" + $("#tradepassword").UITextField("value")
					+"&mintredeem=1";
					$.hsf.startLoading("正在提交申请...");
					$.hsf.ajax.app("trade/sale/sale", tradeData, "saleCallback", function(jsonResult) {
						if (jsonResult.successful) {
							if(action.constant.saleway==3){//货币基金快速赎回确认时间为当天
								$("#date1").html($.hsf.hsTools.mm_dd(jsonResult.commitTime) +" "+ $.hsf.hsTools.dayOfWeek(jsonResult.commitTime));
								$("#date2").html($.hsf.hsTools.mm_dd(jsonResult.commitTime) +" "+ $.hsf.hsTools.dayOfWeek(jsonResult.commitTime));
								$("#date3").html($.hsf.hsTools.mm_dd(jsonResult.commitTime) +" "+ $.hsf.hsTools.dayOfWeek(jsonResult.commitTime));
							}else{
								$("#date1").html($.hsf.hsTools.mm_dd(jsonResult.commitTime) +" "+ $.hsf.hsTools.dayOfWeek(jsonResult.commitTime));
								$("#date2").html($.hsf.hsTools.mm_dd(jsonResult.confirmTime) +" "+ $.hsf.hsTools.dayOfWeek(jsonResult.confirmTime));
								$("#date3").html($.hsf.hsTools.mm_dd(jsonResult.payBackDate) +" "+ $.hsf.hsTools.dayOfWeek(jsonResult.payBackDate));
							}
							$("#second").removeClass('view-active');
							$("#third").addClass('view-active');
							$.hsf.stopLoading();
						} else {
							$.hsf.callFailProcess(jsonResult);
						}
					});
				}
			});
			$("#allBtn").bind("tap", function() {
				$("#applysum").UITextField("value", $("#usableshareDiv").html());
			});
			$("#applysum input").bind("input", function() {
				var _self=$(this),
					val=_self.val(),
					exp=/^[-]?([1-9]{1}[0-9]{0,}(\.[0-9]{0,2})?|0(\.[0-9]{0,2})?|\.[0-9]{1,2})$/g;
				val = val.toString().replace(/,/g, '');
				if(!exp.test(val)) {
					var value = val.replace(/[^0-9,\.]/g,"");
					if(value.substr(value.indexOf(".")).length>3){
						_self.blur();
						$.UIPopup("请输入数字(例:0.00),最高保留两位小数");
					}
					var str=$.hsf.hsTools.formatMoney(value,true);
					$("#applysum").UITextField("value",str );
					return false;
				}
				return false;
			});
			$("input[name='saleway']").bind("change", function() {
				$("#moneyConfirmDiv, #bankConfirmDiv").toggle();
			});
		},
		formValidate : function(){
			var applysum =  parseFloat(action.getApplySum());
			var availableShare = parseFloat($("#usableshareDiv").html());
			var min = parseFloat(action.constant.result.minShare);
			if(!action.constant.result || !action.constant.result.shareList || action.constant.result.shareList.length==0){
				$.UIAlert("代销或第三方资产请到原购买渠道办理，谢谢！");
				return false;
			}
			if(action.constant.saleway==""){
				$.UIPopup("请选择资金赎回至!");
				return false;
			}
			if(isNaN(applysum) || 0 >= applysum){
				$.UIPopup("输入大于0的赎回份额");
				return false;
			}
			if (applysum > availableShare) {
				$.UIPopup("赎回份额不能大于"+availableShare);
				return false;
			}
			if (min) {
				if (availableShare < min) {
					if (applysum != availableShare) {
						$.UIPopup("请全部赎回");
						return false;
					}
				} else {
					if (applysum < min) {
						$.UIPopup("赎回份额不能低于"+min);
						return false;
					}
				}
			}
			return true;
		},
		formValidate2 : function() {
			var tradepassword = $("#tradepassword").UITextField("value");
			if ("" == tradepassword) {
				$.UIPopup("请输入交易密码");
				return false;
			}
			return true;
		},
		selectBank:function(){
			$("#selectBank").UISelectField("change",function(value){
				if(value.indexOf('.html')!=-1){
					$.hsf.hsOpen(value);
					return false;
				}
				var self=$(this),bankLogo;
				self.find("option").each(function() {
					var _self=$(this);
					if(_self.val()==value) bankLogo=_self.attr("m-logo");
				});
				if(action.constant.result.shareList[value].sharetype&&action.constant.result.shareList[value].sharetype=="前收费"){
					action.constant.sharetype="A";
				}else if(action.constant.result.shareList[value].sharetype&&action.constant.result.shareList[value].sharetype=="后收费"){
					action.constant.sharetype="B";
				}else{
					action.constant.sharetype=action.constant.result.shareList[value].sharetype;
				}
				action.constant.requestTradeacco=action.constant.result.shareList[value].tradeacco;

				$("#usableshareDiv").html(action.constant.result.shareList[value].usableremainshare);
				$("#selectBankLogo").removeClass().addClass('bank-logo-min '+bankLogo);
				$(".selectedBankName").html(action.constant.result.shareList[value].bankname);
				$(".selectedBankcardNo2").html("[" +action.constant.result.shareList[value].bankacco +"]");
				$(".selectedBankcardMiniIcon").removeAttr("class").addClass("selectedBankcardMiniIcon bank-logo-tiny " + bankLogo);
			});
		},
		selectSaleway:function(){
			$("#selectSaleway").UISelectField("change",function(value){
				if (value== "0") {
					action.constant.saleway="0";//银行卡
				} else if(value=="1") {
					action.constant.saleway="1";//盛钱宝
				} else if(value=="2"){//请选择
					action.constant.saleway = "";
				}
			});
		},
		getDate : function(){//获取当前日期
			var myDate = new Date();
			var y = myDate.getFullYear();
			var m = myDate.getMonth() + 1;
			var d = myDate.getDate();
			if (m <= 9){
				m = "0"+m;
			}
			if (d <= 9){
				d = "0"+d;
			}
			return y+"."+m+"."+d;
		}
	};
	return action;
});
