﻿define(function (require) {
    var action = {
        constant: {
            fundcode: $.hsf.hsTools.getParam("fundcode"),
            fundname: $.hsf.hsTools.getParam("fundname"),
            requestTradeacco: $.hsf.hsTools.getParam("tradeacco"),
            sharetype: "A",
            day: ["星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六"],
            result: null,
            counter: 0,
            repeatSeconds: 10,
            businflag: "036"
        },
        init: function () {
            $(".fundname").html(action.constant.fundname);
            $(".fundcode").html(action.constant.fundcode);
            var that = this;
            $.hsf.hsTools.investmentSuitability(function () {
                that.packForm();
                that.event();
            });
        },
        packForm: function () {
            $.hsf.startLoading();
            var reqParam = "fundcode=" + action.constant.fundcode;
            reqParam += action.constant.requestTradeacco ? "&tradeacco=" + action.constant.requestTradeacco + "&sharetype=" + action.constant.sharetype : ""
            reqParam += "&antiMoneyBusinestype=036";
            $.hsf.ajax.app("trade/trans/transForm", reqParam, "chargeFormCode", function (jsonResult) {
                if (jsonResult.successful) {
                    // 合规性
                    $.hsf.hsTools.checkHgxForTrade(jsonResult, function () {//检查合规性
                        action.constant.result = jsonResult;
                        action.packFirstPage(jsonResult);
                        action.packBanklist(jsonResult);
                        var targetFunds = jsonResult.targetFunds;
                        $.hsf.ajax.app('product/product/findPage', 'riskcheck=true&riskmatch=true', 'discoverListCallback', function (jsonResult) {
                            if (jsonResult && jsonResult.successful) {
                                var recommendList = jsonResult.recommendList || [];
                                var ts = [];
                                if (recommendList.length === 0) {
                                    ts = targetFunds;
                                } else {
                                    var recommendcodes = recommendList.map(function (item) {
                                        return item.fundcode;
                                    });
                                    recommendList = recommendList.map(function (item) {
                                        item.businflag = item.buybusin;
                                        return item;
                                    });
                                    // 去除重复
                                    targetFunds = targetFunds.filter(function (item) {
                                        return recommendcodes.indexOf(item.fundcode) < 0;
                                    });
                                    ts = recommendList.concat(targetFunds);
                                }
                                action.packTargetlist(ts);
                            } else {
                                // findPage 接口不通
                                action.packTargetlist(targetFunds);
                            }
                        });
                        $.hsf.stopLoading();
                    });
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        // 初始化信披
        initAgreeFunc: function (fundcode) {
            $.platform.getCache("agreeUserInfo", function (r) {
                if (!!r) {
                    $.hsf.hsTools.initAgree(fundcode, r.result.idno, r.result.idtype,$("#main"),$("#fundRatePage"));
                } else {
                    $.hsf.ajax.app("atomicquery/account/logininfo", "", "userInfoCallBack", function (jsonResult) {
                        if (jsonResult && jsonResult.successful) {
                            $.platform.putCache("agreeUserInfo", jsonResult);
                            $.hsf.hsTools.initAgree(fundcode, jsonResult.result.idno, jsonResult.result.idtype,$("#main"),$("#fundRatePage"));
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            });
        },
        packFirstPage: function (jsonResult) {
            $(".fundname").html(jsonResult.fundname);
            $(".fundcode").html(jsonResult.fundcode);
            // 工行快捷显示为快捷_工商银行
            jsonResult.shareList = jsonResult.shareList.map(function (para) {
                if (para.capitalmode == "4" && para.interfacetype == "1") {
                    para.bankname = "快捷_工商银行";
                }
                return para;
            });
            if (jsonResult.shareList.length > 0) {
                $(".selectedBankName").html(jsonResult.shareList[0].bankname +"<br/>"+ "(" + jsonResult.shareList[0].bankacco + ")");
                $(".selectedBankcardNo").html(this.mask(jsonResult.shareList[0].bankacco));
                $("#usableshareDiv").html(jsonResult.shareList[0].usableremainshare);
                $(".selectedBankcardIcon").addClass("bank-logo bank-" + jsonResult.shareList[0].alias);
                $(".selectedBankcardMiniIcon").addClass("bank-" + jsonResult.shareList[0].alias);
            }
        },
        packTargetlist: function (targetFunds) {
            var targetFundSelect = document.getElementById('targetFundSelect');
            targetFundSelect.options.length = 0;
            if (targetFunds.length == 0) {
                $.UIAlert('该基金目前无法转换', function () {
                    $.platform.hsBack();
                })
            }
            if (targetFunds.length > 0) {
                action.constant.selectFund = targetFunds[0].fundcode;
                $('.targetFundname').html(targetFunds[0].fundname);
                $('.targetFundcode').html(targetFunds[0].fundcode);
                action.getWarningList(action.constant.selectFund, targetFunds[0].fundname);
                for (var i = 0; i < targetFunds.length; i++) {
                    targetFundSelect[i] = new Option(targetFunds[i].fundname, i);
                }
                // 这个action.constant.result.targetFunds 不包括被转换的基金 但是页面上却显示了
                // 将action.constant.result.targetFunds 重新赋值
                action.constant.result.targetFunds = targetFunds;
                //
                action.selectTargetFundAction(0); // 下拉框初始化调用不为0 取第一个

            }

        },
        dayOfWeek: function (yyyymmdd) {
            if (typeof yyyymmdd == "string") {
                var dayInt = (new Date(yyyymmdd.substr(0, 4), parseInt(yyyymmdd.substr(4, 2)) - 1, yyyymmdd.substr(6, 2))).getDay();
                var day = action.constant.day[dayInt];
                return day;
            } else {
                return yyyymmdd;
            }
        },
        mm_dd: function (yyyymmdd) {
            if (typeof yyyymmdd == "string") {
                return yyyymmdd.substr(4, 2) + "-" + yyyymmdd.substr(6, 2);
            } else {
                return yyyymmdd;
            }
        },
        mask: function (str) {
            if (str.length > 8) {
                return str.substr(0, 4) + "********" + str.substr(str.length - 4, 4);
            } else {
                return str
            }
        },
        packBanklist: function (jsonResult) {
            var html = "<dd m-type=\"mark\" m-marked=\"\" m-id=\"\"><div m-role=\"cell\" m-layout=\"fit\" class=\"padding-10\"><div m-role=\"cell\" class=\"capitalicon margin-r-10\"><div class=\"bank-logo \"></div></div><div m-role=\"cell\" m-mode=\"y\"><div m-role=\"cell\"><div class=\"bankname2\">招商银行</div><div class=\"m-font-12 m-font-light margin-l-10 cardno\">尾号：4234</div></div><div class=\"m-font-12 m-font-light\" m-margin=\"1 0 0 0\">可用份额:<span class=\"usableremainshare m-color-red margin-l-10\">23423432</span></div></div></div></dd>";
            var $bankcardList = $("#bankcardList");
            var $dl = $bankcardList.find("dl");
            for (var index in jsonResult.shareList) {
                var $html = $(html);
                $html.find(".bankname2").html(jsonResult.shareList[index].bankname);
                $html.find(".cardno").html("(尾号:" + this.mask2(jsonResult.shareList[index].bankacco) + ")");
                $html.attr("m-id", index);
                $html.find(".bank-logo").addClass("bank-" + jsonResult.shareList[index].alias);
                $html.find(".usableremainshare").html(jsonResult.shareList[index].usableremainshare + "份");
                $dl.append($html);
            }
            $bankcardList.find("dd").first().attr("m-marked", "yes");
            $bankcardList.UITableView("refresh");
        },
        mask2: function (str) {
            return str.length > 4 ? str.substr(str.length - 4, 4) : str;
        },
        getApplySum: function () {
            return $.hsf.hsTools.recoveryMoney($("#applysum").UITextField("value"));
        },
        tobuy: function () {
            var navfor = $("#nextTo2Btn").attr("for");
            action.renderBWarning(function () {
                $(".confirmsum").html(action.getApplySum() + "份");
                var shareTypeText = $("[m-name='sf-type']").UIRadio("key");
                $(".fee1").html(action.constant.sharetype == "A" ? "前收费" : "后收费");
                $("#first").removeClass('view-active');
                $("#" + navfor).addClass('view-active');
                action.sandclock.start();
            });
        },
        event: function () {
            $("#trade-agreement-agree").bind("tap", function () {
                var checkContract2 = $("#checkContract2");
                if (!checkContract2.is(':checked')) {
                    $.UIPopup("请确认已阅读《风险不匹配警示函》和《投资者确认书》!");
                } else {
                    $("#tradeAgreementPage").hide();
                    $("#first").addClass('view-active');
                    action.tobuy();
                    return false;
                }
                return false;
            });
            $("#trade-agreement-cancel").bind("tap", function () {
                $("#tradeAgreementPage").hide();
                $("#first").addClass('view-active');
                return false;
            });
            $("#limitBtn, #bankcardSelect,#nextTo2Btn, #targetSelect").bind("tap", function () {
                if ($("#nextTo2Btn").attr("m-state") == "disabled") {
                    return false;
                }
                if ("nextTo2Btn" == $(this).attr("id")) {
                    var above_risk = $(this).hasClass("above_risk");
                    if (above_risk) {
                        $.UIAlert("您的风险等级过低，不允许转换该产品！");
                        return false;
                    }
                    if (!$.hsf.hsTools.checkRead()) {
                        return false;
                    }
                    if (!action.formValidate()) {
                        return;
                    }
                    var navfor = $(this).attr("for");
                    action.renderCWarning(function () {
                        action.tobuy();
                    });
                    return false;
                }
                $("#first").removeClass('view-active');
                $("#" + $(this).attr("for")).addClass('view-active');
                return false;
            });
            $("#limitBackBtn, #bankcardBackBtn, #secondBackBtn, #targetBackBtn").on("tap", function () {
                if ($(this).attr("id") == "secondBackBtn") {
                    action.sandclock2.start();
                }
                $(this).parents(".view").removeClass('view-active');
                $("#tradepassword").UITextField("value", "");
                $("#first").addClass('view-active');
                return false;
            });
            $("#bankcardList").UITableView("mark", function (result) {
                $(".selectedBankName").html(action.constant.result.shareList[result].bankname + "(" + action.constant.result.shareList[result].bankacco + ")");
                $(".selectedBankcardNo").html(action.mask(action.constant.result.shareList[result].bankacco));
                //				$(".selectedBankcardNo2").html("(尾号" + action.mask2(action.constant.result.shareList[result].bankacco) + ")");
                $("#usableshareDiv").html(action.constant.result.shareList[result].usableremainshare);
                $(".selectedBankcardMiniIcon").removeAttr("class").addClass("selectedBankcardMiniIcon bank-logo-tiny bank-" + action.constant.result.shareList[result].alias);
                $(".selectedBankcardIcon").removeAttr("class").addClass("selectedBankcardIcon bank-logo bank-" + action.constant.result.shareList[result].alias);
                $(this).parents(".view").removeClass('view-active');
                $("#first").addClass('view-active');
                $("#applysum").UITextField("value", "");
                $(".radio-btn").siblings().removeClass('on');
            });
            $("#applysum input").bind("input", function () {
                var _self = $(this),
                    val = _self.val(),
                    exp = /^[-]?([1-9]{1}[0-9]{0,}(\.[0-9]{0,2})?|0(\.[0-9]{0,2})?|\.[0-9]{1,2})$/g;
                val = val.toString().replace(/,/g, '');
                if (!exp.test(val)) {
                    var value = val.replace(/[^0-9,\.]/g, "");
                    if (value.substr(value.indexOf(".")).length > 3) {
                        _self.blur();
                        $.UIPopup("请输入数字(例:0.00),最高保留两位小数");
                    }
                    var str = $.hsf.hsTools.formatMoney(value, true);
                    $("#applysum").UITextField("value", str);
                    return false;
                }
                return false;
            });
            $("#saleBtn").bind("tap", function () {
                $("#tradepassword input").blur();
                if (!action.sandclock.readyStart()) return false;
                if ($(this).attr('m-state') == 'disabled') {
                    return false;
                }
                if (action.formValidate2()) {
                    var selectCard = action.constant.result.shareList[$("#bankcardList").UITableView("marked")];
                    var tradepassword = $("#tradepassword").UITextField("value");
                    var tradeData = "saleway=2" + "&sharetype=" + action.constant.sharetype + "&fundcode=" + action.constant.fundcode + "&targetfundcode=" + action.constant.selectFund + "&tradeacco=" + selectCard.tradeacco + "&applysum=" + action.getApplySum() + "&tradepassword=" + $("#tradepassword").UITextField("value") + "&mintredeem=0" + "&targetsharetype=" + action.constant.sharetype;
                    // 信披入参
                    if ($.hsf.infoDisclosure.enable) {
                      var businflag = action.constant.businflag == "036" ? "036" : "024";
                      if ("024"==businflag) {
                        tradeData += "&sharetype=A";
                      }
                      tradeData += "&channelno=3"+"&antiMoneyBusinestype="+businflag
                    }
                    $.hsf.startLoading("正在提交申请...");
                    $.hsf.ajax.app("trade/trans/trans", tradeData, "saleCallback", function (jsonResult) {
                        if (jsonResult.successful) {
                            $("#saleBtn").attr('m-state', 'disabled').unbind('tap');
                            if (action.constant.warningResult.riskmatchResult.riskflag == "1"
                                || action.constant.warningResult.riskmatchResult.riskflag == "2"
                                || action.constant.warningResult.riskmatchResult.riskflag == "3") {
                                jsonResult.tradeResult && action.makeTrace("C", jsonResult.tradeResult.applyserial || "");
                            }
                            $("#date1").html(action.mm_dd(jsonResult.commitTime) + " " + action.dayOfWeek(jsonResult.commitTime));
                            if (jsonResult.confirmTime) {
                                $("#date2").html(action.mm_dd(jsonResult.confirmTime) + " " + action.dayOfWeek(jsonResult.confirmTime));
                            } else {
                                $("#date2").html("--");
                            }
                            $("#second").removeClass('view-active');
                            $("#third").addClass('view-active');
                            $.hsf.stopLoading();
                        } else {
                            $.hsf.callFailProcess(jsonResult);
                        }
                    });
                }
            });
            $("#allBtn").bind("tap", function () {
                $("#applysum").UITextField("value", $("#usableshareDiv").html());
            });
            //			$("#targetTableView").UITableView("mark", function(result) {
            //				$(".targetFundname").html(action.constant.result.targetFunds[result].fundname);
            //				$(".targetFundcode").html(action.constant.result.targetFunds[result].fundcode);
            //				action.constant.selectFund = action.constant.result.targetFunds[result].fundcode;
            //				action.changeShareDiv(action.constant.result.targetFunds[result].sharetype);
            //				$("#targetPage").removeClass('view-active');
            //				$("#first").addClass('view-active');
            //			});
            this.radioBtn();
            this.selectTargetFund();
        },
        formValidate: function () {
            var applysum = action.getApplySum();
            var moneysum = $("#moneyacco").find("option:selected").attr("sum");
            var max = $("#usableshareDiv").html();
            var targetSelectFund = action.constant.selectFund;
            if (!targetSelectFund) {
                $.UIPopup("请选择转入基金");
                return false;
            }
            if ("" == applysum) {
                $.UIPopup("请输入转换份额!");
                return false;
            }
            if (0 >= applysum) {
                $.UIPopup("转换份额必须大于0!");
                return false;
            }
            if (parseFloat(applysum) > parseFloat(max)) {
                $.UIPopup("转换份额不能大于" + max);
                return false;
            }
            return true;
        },
        formValidate2: function () {
            var tradepassword = $("#tradepassword").UITextField("value");
            if ("" == tradepassword) {
                $.UIPopup("请输入交易密码");
                return false;
            }
            return true;
        },
        // 转换份额选择按钮
        radioBtn: function () {
            $(".radio-btn").on('tap', function () {
                var _self = $(this);
                _self.addClass('on').siblings().removeClass('on');
                switch (Number(_self.attr("value"))) {
                    case 0:
                        $("#applysum").UITextField("value", $.hsf.hsTools.decimal2($("#usableshareDiv").html() / 4));
                        break;
                    case 1:
                        $("#applysum").UITextField("value", $.hsf.hsTools.decimal2($("#usableshareDiv").html() / 3));
                        break;
                    case 2:
                        $("#applysum").UITextField("value", $.hsf.hsTools.decimal2($("#usableshareDiv").html() / 2));
                        break;
                    case 3:
                        $("#applysum").UITextField("value", $("#usableshareDiv").html());
                        break;
                    default:
                        break;
                }
                return false;
            });
        },
        selectTargetFund: function () {
            $("#selectTargetFund").UISelectField("change", function (value) {
                action.selectTargetFundAction(value);
                return false;
            });
        },
        // 选择
        selectTargetFundAction:function(value){
            $(".targetFundname").html(action.constant.result.targetFunds[value].fundname);
            $(".targetFundcode").html(action.constant.result.targetFunds[value].fundcode);
            action.constant.selectFund = action.constant.result.targetFunds[value].fundcode;
            action.initAgreeFunc(action.constant.selectFund); // 根据基金代码显示协议
            if (action.constant.result.targetFunds[value].businflag == "036") {
                action.constant.businflag = "036";
            } else {
                action.constant.businflag = "024";
            }

            //				aaction.constant.sharetype=(action.constant.result.targetFunds[value].sharetype);
            //				$("#targetPage").removeClass('view-active');
            //				$("#first").addClass('view-active');
            action.getWarningList(action.constant.selectFund, action.constant.result.targetFunds[value].fundname);
        },
        sandclock2: {
            run: function () {
                if (action.constant.counter == 0) {
                    $("#nextTo2Btn").attr("m-state", "").html("转换");
                    action.constant.counter = -1;
                } else {
                    $("#nextTo2Btn").html((action.constant.counter--) + " 秒");
                    action.constant.timer = setTimeout(action.sandclock2.run.bind(action), 1000);
                }
            },
            start: function () {
                if (action.constant.timer) clearTimeout(action.constant.timer);
                action.constant.counter = action.constant.repeatSeconds;
                $("#nextTo2Btn").attr("m-state", "disabled").html((action.constant.counter--) + " 秒");
                setTimeout(action.sandclock2.run.bind(action), 1000);
            },
            readyStart: function () {
                if (action.constant.counter == -1) {
                    return true;
                } else {
                    return false;
                }
            }
        },
        sandclock: {
            run: function () {
                if (action.constant.counter == 0) {
                    $("#saleBtn").attr("m-state", "");
                    $("#saleBtn").html("确认");
                    // $("#nextTo2Btn").attr("m-state","");
                    // $("#nextTo2Btn").html("转换");
                    action.constant.counter = -1;
                } else {
                    $("#saleBtn").html((action.constant.counter--) + " 秒");
                    // $("#nextTo2Btn").html((action.constant.counter--)+" 秒");
                    action.constant.timer = setTimeout(action.sandclock.run.bind(action), 1000);
                }
            },
            start: function () {
                if (action.constant.timer) clearTimeout(action.constant.timer);
                action.constant.counter = action.constant.repeatSeconds;
                // $("#nextTo2Btn").attr("m-state","disabled");
                // $("#nextTo2Btn").html((action.constant.counter--)+" 秒");
                $("#saleBtn").attr("m-state", "disabled").html((action.constant.counter--) + " 秒");
                setTimeout(action.sandclock.run.bind(action), 1000);
            },
            readyStart: function () {
                if (action.constant.counter == -1) {
                    return true;
                } else {
                    return false;
                }
            }
        },
        renderAWarning: function (jsonResult) {
            //如果不是专业投资者,显示tip
            if (jsonResult.pubprofessionflag != "1") {
                $("#tip").html(jsonResult.warningAContent).UITip("show");
                this.makeTrace("A");//留痕
            }
        },
        renderBWarning: function (callback) {
            var that = this;
            var jsonResult = action.constant.warningResult;
            if (jsonResult.pubprofessionflag != "1" && jsonResult.productRiskLevel == $.hsf.theHighestRiskLevel) {
                $.UIConfirm({
                    "html": jsonResult.warningBContent,
                    "submitText": "取消",
                    "cancelText": "确认"
                }, function (result) {
                    if (result == "no") {
                        that.makeTrace("B");
                        callback && callback.call(that);
                    }
                });
            } else {
                callback && callback.call(that);
            }
        },
        renderCWarning: function (callback) {
            var that = this;
            var jsonResult = action.constant.warningResult;
            if (jsonResult.riskmatchResult.riskflag == "1" || jsonResult.riskmatchResult.riskflag == "2" || jsonResult.riskmatchResult.riskflag == "3") {//不匹配
                $("#tradeAgreementPage").show();
                $("#first").removeClass('view-active');
            } else {
                callback && callback.call(that);
            }
        },
        getWarningList: function (fundcode, fundname) {
            $.hsf.startLoading();
            var data = "businflag=137&fundcode=" + fundcode + "&sharetype=A" + "&warningchannel=" + $.platform.warningchannel;
            $.hsf.ajax.app("comquery/common/warninglist", data, "warninglistCallback", function (jsonResult) {
                if (jsonResult.successful) {
                    jsonResult.fundcode = fundcode;
                    action.constant.warningResult = jsonResult;
                    action.renderAWarning(jsonResult);
                    //$(".notice-box").html(jsonResult.warningCContent);
                    $("#showfundname").html(fundname);
                    $("#showfundnamerisklevel").html(jsonResult.riskmatchResult.fundriskStr);
                    $("#custrisklevel").html(jsonResult.riskmatchResult.riskbilityStr);
                    action.renderLowRiskLimit(jsonResult);
                    $.hsf.stopLoading();
                } else {
                    $.hsf.callFailProcess(jsonResult);
                }
            });
        },
        makeTrace: function (type, requestno, pflag) {
            var jsonResult = action.constant.result;
            var warningResult = action.constant.warningResult;
            requestno = requestno || "";
            var typestr = "warning" + type + "No";
            this.requestTrace({
                warningno: warningResult[typestr],
                businflag: "036",
                fundcode: warningResult.fundcode,
                content: warningResult["warning" + type + "Content"],
                fundrisklevel: warningResult.productRiskLevel,
                custrisktype: warningResult.accoRiskability,
                requestno: requestno
            });
        },
        requestTrace: function (data) {
            var param = $.map(data, function (value, key) {
                return key + "=" + value
            }).join("&");
            $.hsf.ajax.app("account/risk/trace", param, "traceCallback", function (jsonResult) {
                if (jsonResult.successful) {
                }
            });
        },
        renderLowRiskLimit: function (jsonResult) {
            var minriskflag = jsonResult.minriskflag;
            var fundrisklevel = jsonResult.productRiskLevel;
            var riskflag = jsonResult.riskmatchResult.riskflag;
            if (minriskflag && fundrisklevel) {
                if ((minriskflag == "1" && fundrisklevel > $.hsf.theLowestRiskLevel) || riskflag == "3") {
                    $("#nextTo2Btn").addClass("above_risk").attr("m-state", "disabled");
                } else {
                    $("#nextTo2Btn").attr("m-state", "").removeClass("above_risk")
                }
            } else {
                $("#nextTo2Btn").attr("m-state", "").removeClass("above_risk")
            }
        }
    };
    return action;
});
